   This file documents emacs-w3m, an Emacs interface to w3m.

   Copyright (C) 2000, 2001, 2002, 2003 TSUCHIYA Masatoshi

   This edition is for emacs-w3m version 1.3.6.

   Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU General Public License, Version 2 or any
later version published by the Free Software Foundation.

   This document is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

   You should have received a copy of the GNU General Public License
along with this document; if not, you can either send email to this
document's maintainer or write to: The Free Software Foundation, Inc.;
59 Temple Place, Suite 330; Boston, MA 02111-1307, USA.

Emacs-w3m User's Manual
***********************

                                         The emacs-w3m development team

   This manual corresponds to emacs-w3m version 1.3.6.

Known Problems

Tips

Mailing List

Emacs-w3m Functions

Preliminary remarks
*******************

W3 (http://www.cs.indiana.edu/elisp/w3/docs.html) is known as the most
popular WEB browser on Emacs, but it works so slowly that we want a
simple and speedy alternative.  w3m (http://w3m.sourceforge.net/) is a
pager with WWW capability, developed by Akinori ITO.  Although it is a
pager, it can be used as a text-mode WWW browser.  So we developed a
simple Emacs interface to w3m.

   Our special thanks go to Akinori ITO and the w3m team for the
excellent w3m program.  We would also like to thank everybody who has
submitted comments, suggestions, and bug fixes.  Even though we're not
aware of any problems, all responsibility for this program is ours (the
emacs-w3m development team), but there is absolutely no warranty.  The
emacs-w3m program was first created by TSUCHIYA Masatoshi in June 2000.

   See also the emacs-w3m official page (http://emacs-w3m.namazu.org/).

It's so easy to begin to use emacs-w3m
**************************************

Emacs-w3m may have already been installed on your system, in which case
you can skip this section and begin to use the program at once.  If
you're not that lucky, read on to learn how to install emacs-w3m.

What version of Emacs can be used?
==================================

You can run emacs-w3m in various versions of Emacsen listed below:

`Emacs 21.x'
     No additional package is required.

`XEmacs 21.x'
     The APEL package and the `gifsicle' program are required (see
     Other Requirements).  We recommend using the most recent XEmacs
     21.4 since that version of XEmacs seems to be most stable.

`Emacs 20.x'
     No additional package is required.  Furthermore, you can see
     monochrome bitmap images inline by using the BITMAP-MULE package
     (see Other Requirements).

`Emacs 19.34 (including Mule 2.3)'
     The APEL package, the `new custom' package and the `regexp-opt.el'
     module are required.  If you are using Mule 2.3 based on Emacs
     19.34, you can see monochrome bitmap images inline by using the
     BITMAP-MULE package (see Other Requirements).

Using w3m: the reason why emacs-w3m is fast
===========================================

Emacs-w3m uses the external w3m program as a back-end to retrieve web
contents and as an HTML rendering engine; that's how we could create an
accelerated Emacs web browser with asynchronous operation.

   You must install the latest w3m, it is available at:

   `http://prdownloads.sourceforge.net/w3m/'

Things required to run emacs-w3m
================================

Depending on the version of Emacs, third party packages may be required.
This section provides resources to help you find and install them.

`APEL'
     Indispensable to XEmacs, Emacs 19.34 or Mule 2.3.  You should
     install APEL before building emacs-w3m.  APEL is available at:

     `ftp://ftp.m17n.org/pub/mule/apel/apel-10.6.tar.gz'

     Note that you must not use the APEL XEmacs package (which is
     contained in SUMO).  If you have already installed the APEL XEmacs
     package, use the following directives to replace it with APEL
     which is linked above (you can also use the same directives in
     order to newly install APEL):

          % rm -fr /usr/local/lib/xemacs/xemacs-packages/lisp/apel
          % cd apel-10.6
          % make install-package XEMACS=xemacs-21.4.x\
            PACKAGEDIR=/usr/local/lib/xemacs/xemacs-packages

`gifsicle'
     Indispensable to XEmacs.  There is a known bug in all XEmacs 21.x
     series that won't let it display optimized animated gifs correctly
     or may make it crash when some kind of an interlaced gif image is
     displayed.  Emacs-w3m uses the `gifsicle' program to convert gif
     data in order to make it possible to be handled by XEmacs 21.x.
     It is available at:

     `http://www.lcdf.org/gifsicle/'

`ImageMagick'
     If the `convert' program bundled with the ImageMagick package is
     available on your system, emacs-w3m will use it for resizing
     images or converting `favicon' images into a format Emacs can
     handle.  Emacs-w3m works without ImageMagick, but it will improve
     the appearance of web pages.  You can get the ImageMagick package
     from:

     `ftp://ftp.imagemagick.org/pub/ImageMagick/'

     We have roughly checked that the ImageMagick version 5.4.0-5 and
     later can be used for manipulating `favicon' images.

`BITMAP-MULE'
     Used to display monochrome bitmap images inline in Emacs 20.x or
     Mule 2.3 based on Emacs 19.34.  It isn't necessary if you aren't
     interested in images.  It is available at:

     `ftp://ftp.jpl.org/pub/elisp/bitmap/'

`new custom'
     Indispensable to Emacs 19.34 (including Mule 2.3).  The `custom'
     library bundled with Emacs 19.34 is too _old_, its API is
     incompatible with the `new custom' bundled with recent Emacsen.
     The `new custom' for Emacs 19.34 is available at:

     `ftp://ftp.dina.kvl.dk/pub/Staff/Per.Abrahamsen/custom/custom-1.9962.tar.gz'

     Note that Mule 2.3 users should slightly modify it by applying the
     following patch:

          ----8<------8<------8<------8<------8<------8<------8<------8<----
          --- custom-1.9962/cus-face.el~	Wed Mar  4 19:52:39 1998
          +++ custom-1.9962/cus-face.el	Mon Mar  9 08:05:33 1998
          @@ -96,7 +96,7 @@
                 "Define a new FACE on all frames, ignoring X resources."
                 (interactive "SMake face: ")
                 (or (internal-find-face name)
          -	  (let ((face (make-vector 8 nil)))
          +	  (let ((face (make-vector face-vector-length nil)))
           	    (aset face 0 'face)
           	    (aset face 1 name)
           	    (let* ((frames (frame-list))
          ----8<------8<------8<------8<------8<------8<------8<------8<----

`regexp-opt.el'
     Indispensable to Emacs 19.34 (including Mule 2.3).  The
     `regexp-opt.el' file is included in the `attic/' directory of the
     emacs-w3m distribution.  You may simply copy it somewhere (e.g.
     `site-lisp/' directory) and perform byte-compilation as follows:

          # cp -p attic/regexp-opt.el /usr/local/share/emacs/19.34/site-lisp
          # cd /usr/local/share/emacs/19.34/site-lisp
          # emacs -batch -q -no-site-file -f batch-byte-compile regexp-opt.el

`FLIM'
     The FLIM package is required to use the `shimbun' library.  The
     `shimbun' library is a collection of tools for reading a web
     newspaper, you can use it with Gnus, Mew, Nana-gnus, T-gnus,
     Wanderlust, etc. See Shimbun Library.

     Note that the FLIM package requires the APEL package even if you
     are using Emacs 20.x or Emacs 21.x.  Therefore, you must install
     both APEL and FLIM if you would like to use the `shimbun' library.
     The FLIM package is available at:

     `ftp://ftp.m17n.org/pub/mule/flim/flim-1.14/'

`Mule-UCS'
     The Mule-UCS Emacs Lisp package makes your Emacs handle the Unicode
     system.  We recommend you install this package so that emacs-w3m
     can display pages written in UTF-8, etc.  It is available at:

     `ftp://ftp.m17n.org/pub/mule/Mule-UCS/Mule-UCS-0.84.tar.gz'

     If you are an XEmacs user, the compiled package is here:

     `ftp://ftp.xemacs.org/packages/mule-ucs-1.04-pkg.tar.gz'

Installing emacs-w3m
====================

See the official page `http://emacs-w3m.namazu.org/' for instructions
on how to get the latest emacs-w3m.  Is everything ready?  Now, let's
begin.

   In order to install emacs-w3m on non-UNIX-like systems (or any system
lacking the ability to execute the `configure' script or has no `make'
command), skip this section and go to the next section
Non-UNIX-like systems.

  1. First, extract a tarball of the emacs-w3m distribution and enter
     the top directory as follows:

          % tar zxf emacs-w3m-1.3.6.tar.gz
          % cd emacs-w3m-1.3.6

     If you've checked out emacs-w3m from CVS, you have to run
     `autoconf' with no argument to generate the `configure' script.

  2. Run the `configure' script.

          % ./configure

     _Important notice to Gnus users_:

     If multiple versions of Gnus are installed on your system (it is
     likely that there are the released version and the development
     version of Gnus), make sure that the `load-path' contains the
     directory where the version you use is installed (check for the
     `gnus.elc' file).  You can ensure that with the `--with-addpath'
     option as follows:

          % ./configure --with-addpath=/usr/local/share/emacs/site-lisp/gnus

     If you've installed APEL, FLIM or something in non-standard
     directories other than the default `load-path', you must specify
     them using the `--with-addpath' option as follows (you may also
     include the Gnus directory in it separated with `:'):

          % ./configure --with-addpath=/opt/share/apel:/opt/share/flim

  3. Just run `make' and `make install'.  See also the next step if you
     are using XEmacs.

          % make
          % make install

     All Lisp and info files will be installed in the appropriate
     directories.  Now, how do you know what files will go where?  To
     know it beforehand, use this:

          % make what-where

     If you are using Emacs 21 or XEmacs, you had better install icon
     image files.  To do this:

          % make install-icons

  4. You can also install emacs-w3m as an XEmacs package using `make
     install-package' instead of `make install' as follows:

          % make
          % make install-package

     In this case, you don't have to execute `make install-icons'.

     If you need to specify the package directory, there are two ways
     to do that:

        * Use the `configure' option `--with-packagedir='.  For example:

               % ./configure --with-packagedir=/opt/xemacs/xemacs-packages
               % make what-where
               % make
               % make install-package

        * Use the `PACKAGEDIR' variable.  For example:

               % ./configure
               % make what-where PACKAGEDIR=/opt/xemacs/xemacs-packages
               % make
               % make install-package PACKAGEDIR=/opt/xemacs/xemacs-packages

Installing on non-UNIX-like systems
===================================

If you cannot execute the `configure' script on your system, or if no
`make' command is available, cast the following spell:

     % emacs -batch -q -no-site-file -l w3mhack.el NONE -f w3mhack-nonunix-install

   If APEL, FLIM (or any other library) aren't installed in the
ordinary places, the installer will leave them out.  In such a case, it
is necessary to tell those places to the installer as shown below:

     % emacs -batch -q -no-site-file -l w3mhack.el //c/share/apel://c/share/flim -f w3mhack-nonunix-install

Minimal settings to run emacs-w3m
=================================

There are only fundamental items in this section.  Many variables which
can be customized by user's preferences are described in
Customizable Variables.

`Autoloads'
     You never need to set the autoload definitions if you've emacs-w3m
     installed as an XEmacs package (see Installing Emacs-w3m)
     because of the `w3m/auto-autoloads.el' file.  If not, put the
     following line in your `~/.emacs' file:

          (autoload 'w3m "w3m"
            "Visit the WWW page using w3m" t)

     In addition to this, put the following setups if needed:

          (autoload 'w3m-find-file "w3m"
            "Find a local file using emacs-w3m." t)
          (autoload 'w3m-browse-url "w3m"
            "Ask emacs-w3m to show a URL." t)
          (autoload 'w3m-antenna "w3m-antenna"
            "Report changes of web sites." t)
          (autoload 'w3m-bookmark-view "w3m-bookmark"
            "Show bookmarks." t)
          (autoload 'w3m-dtree "w3m-dtree"
            "Display a directory tree." t)
          (autoload 'w3m-namazu "w3m-namazu"
            "Search files with Namazu." t)
          (autoload 'w3m-perldoc "w3m-perldoc"
            "View Perl documents" t)
          (autoload 'w3m-search "w3m-search"
            "Search words using emacs-w3m." t)
          (autoload 'w3m-weather "w3m-weather"
            "Display a weather report." t)

`Startup File'
     We recommend using the `~/.emacs-w3m' file (which is the default
     value of `w3m-init-file') when you twiddle some variables of
     emacs-w3m.  This file is similar to `~/.emacs', but is read when
     emacs-w3m starts.  However, note that there are commands which
     shouldn't be put there, for example, the autoload definitions as
     mentioned above.

`Proxy Gateway'
     If you are behind a firewall and only have access to foreign web
     sites through the proxy gateway, you need to instruct w3m to use
     the proxy gateway.

     There are some ways to do this, one is to set the `http_proxy'
     environment variable globally in the shell something like:

          setenv http_proxy http://proxy.hogege.com:8000/

     Another way is to customize the `w3m-command-arguments' variable to
     add the options `-o' and
     `http_proxy=http://PROXY_SERVER_NAME:PORT/'.

     This can also be done in your `~/.emacs-w3m' file as shown below:

          (setq w3m-command-arguments
                (nconc w3m-command-arguments
                       '("-o" "http_proxy=http://proxy.hogege.com:8000/")))

     To specify `no_proxy' hosts, which shouldn't be connected to with
     proxy gateways, you can set the `no_proxy' (note that it is not
     `no-proxy') environment variable with the comma separated host
     names, or set the `w3m-no-proxy-domains' variable with a list of
     domain names (not host names) as follows:

          (setq w3m-no-proxy-domains '("local.com" "neighbor.com"))

     See also the documentation for the `w3m-command-arguments-alist'
     variable to use regexps to specify the `no_proxy' hosts.

Basic usage
***********

Let's go netsurfing!
====================

Go ahead, just try it
---------------------

You can invoke emacs-w3m using three different commands, listed below.
Try one of these commands: a web page is displayed in an Emacs buffer
named "*w3m*", meaning that it is an emacs-w3m buffer.  As you will
probably notice, the major mode for an emacs-w3m buffer is `w3m-mode',
there are also minor modes (see Managing Bookmarks).

   This section explains the most fundamental usage of these commands,
see Emacs-w3m Functions for more information on each command.
And see Customizable Variables for details on the variables
which affect the behavior of emacs-w3m by user's preferences.

`w3m'
     Start emacs-w3m, displaying the homepage specified in the
     `w3m-home-page' variable.  The default value for `w3m-home-page'
     is "about:".  Set the `w3m-quick-start' variable to `nil' if each
     time you want to specify URL.

     You can also use this as an Emacs batch command.  Here's an
     example:

          % emacs -f w3m

     To specify a URL, you could also use:

          % emacs -f w3m http://emacs-w3m.namazu.org/

`w3m-find-file'
     Prompt for a local file name in the minibuffer, and display it in
     emacs-w3m.

`w3m-browse-url'
     Prompt for a URL in the minibuffer, and display it in emacs-w3m.
     This command is provided, if anything, in order to start emacs-w3m
     from other application programs.

   Moving in an emacs-w3m buffer won't be painful if you're an Emacs
user already, since many of the standard keys work as intended.  For
instance, `C-n', `C-v' and `C-s' (which are commonly used to move down
one line, one page, or search downwards for a word) are valid keys in
an emacs-w3m buffer.

   To follow a link, use the `RET' key.  You have to move the point to
a link to do this; links are easily recognizable in a buffer because
they are not displayed like ordinary text: they can be underlined, or
have a different color.  The face `w3m-anchor-face' controls how they
are to be displayed (see Customizable Variables).

`RET'
     Display the page pointed by the link under point
     (`w3m-view-this-url').

     The exact behavior of this command depends on the properties of
     the link under point, and on whether you give it a prefix argument
     or not.  See Emacs-w3m Functions for details.

   As mentioned above, you can be prompted for a URL when you use the
command `M-x w3m', by setting the `w3m-quick-start' variable to `nil'.
In an emacs-w3m buffer, there are also two popular ways to go to new
pages by entering their URLs.

`RET'
     In an emacs-w3m buffer, you can be prompted for a URL in the
     minibuffer and make emacs-w3m display the corresponding page by
     hitting <RET> after moving the point to the URL displayed in the
     `header-line'.  This feature will feel familiar to you if you are
     used to GUI-based web browsers like Mozilla.  Detailed
     explanations about this can be found in Emacs-w3m Functions
     (`w3m-view-this-url').

`g'
     You can be prompted for a URL in the minibuffer and make emacs-w3m
     display the corresponding page by typing the <g> key (independently
     of the position of the point) in an emacs-w3m buffer.  This
     binding will be familiar to you if you already use Gnus or Mew
     (`w3m-goto-url').

`c'
     Display the URL of the page being displayed in the echo area and
     put it into the `kill-ring' (`w3m-print-current-url').

`u'
     Display the URL under point in the echo area and put it into the
     `kill-ring' (`w3m-print-this-url').

   If the page you are reading is today's news or someone's diary, it
may have been updated since you loaded it.  You can fetch the newest
contents of the page by using the following command.  (This command can
also be useful to force a full redisplay of the page if it looks
broken.)

`R'
     Reload the page which is currently displayed
     (`w3m-reload-this-page').

Moving from place to place in a page
------------------------------------

Being able to use familiar Emacs movement bindings while browsing a web
page probably fascinates you already.  Believe it or not, there is
more!  Since we value your time, we have added keys to move the point,
scroll the page or find links in a very fast way.  When you master
them, you will understand how handy they are.

   The keys are assigned so that scroll commands can be called using
shorter keystrokes than the standard key bindings of Emacs.  And since
places where you can input text are pretty specific in web pages (see
Submitting Forms), most keys have special meanings and aren't
assigned to `self-insert-command' anymore.

`SPC'
     Scroll downwards.  You may be used to it if you have been using the
     `more' command, the `less' command, or the `view-mode' on Emacs
     (`w3m-scroll-up-or-next-url').

`DEL'
     Scroll upwards.  You may be used to it if you have been using the
     `less' command or the `view-mode' on Emacs
     (`w3m-scroll-down-or-previous-url').

`>'
     Scroll to the left.  The scroll step is given by the
     `w3m-horizontal-scroll-columns' variable, default 10
     (`w3m-scroll-left').

`<'
     Scroll to the right.  The scroll step is given by the
     `w3m-horizontal-scroll-columns' variable, default 10
     (`w3m-scroll-right').

`.'
     Shift to the left (a fine level horizontal scrolling).  The shift
     step is given by the `w3m-horizontal-shift-columns' variable,
     default 2 (`w3m-shift-left').

`,'
     Shift to the right (a fine level horizontal scrolling).  The shift
     step is given by the `w3m-horizontal-shift-columns' variable,
     default 2 (`w3m-shift-right').

`M-l'
     Scroll horizontally so that the current position is centered
     (`w3m-horizontal-recenter').

   The `w3m-mode' major mode defines commands to move to various kinds
of things; namely links, forms, and images (whether they are displayed
or not).

   Let's consider this simple example: suppose we want to search for a
word on the widely-known Google search engine.  Step one: open
`http://www.google.com' in emacs-w3m.  Step two: after opening the
page, hit `]'.  Tadaa!  The point has been moved to the first form
input in the page, you can now hit `RET' to enter something in it, and
then `C-c C-c' to submit it.  Without this command, you would have had
to move into the page using `C-n', `C-f' and so forth, it would have
been a real pain.

<TAB>
     Move the point to the next anchor.  More strictly speaking, move
     the point forward to the nearest anchor.

`M-<TAB>'
`S-<TAB>'
     Move the point to the previous anchor.  More strictly speaking,
     move the point backward to the nearest anchor
     (`w3m-previous-anchor').

`]'
     Move the point to the next form.  More strictly speaking, move the
     point forward to the nearest form (`w3m-next-form').

`['
     Move the point to the previous form.  More strictly speaking, move
     the point backward to the nearest form (`w3m-previous-form').

`}'
     Move the point to the next image.  More strictly speaking, move the
     point forward to the nearest image (`w3m-next-image').

`{'
     Move the point to the previous image.  More strictly speaking,
     move the point backward to the nearest image
     (`w3m-previous-image').

Moving from page to page
------------------------

This section explains how to move from page to page, but not by
following links or inputing URLs (these ways of moving are explained in
Launching and Jumping).

   This includes commands to move backwards and forwards in history (the
familiar "Back" and "Forward" from other browsers), and the obligatory
"Go to the home page" feature.  You will probably understand this
better after reading the Tracing History section.

`B'
     Move back one page in history (`w3m-view-previous-page').  With a
     numeric argument ARG, move back ARG pages.  This is the preferred
     way to go back in time.

`N'
     Move forward one page in history (`w3m-view-next-page').  Of
     course, this will work only if you've used `B' to move back in
     history.  If called with a numeric argument ARG, move forward ARG
     pages.  This command actually allows you to go back to the future!

`H'
     Move to the home page (`w3m-gohome').  You can specify the URL of
     the home page by customizing the `w3m-home-page' variable
     ("about:" by default).

   These commands are exclusive features of emacs-w3m, we were able to
obtain patents on them, so you won't find them anywhere else.  That's
why you must learn to use them today!  (Just kidding.)

`^'
     Attempt to move to the parent directory of the page currently
     displayed.  For instance, it will attempt to move to "http://foo/"
     when "http://foo/bar/" is displayed.  This function has been
     implemented because of the following observation: users of web
     browsers often have to move up one level of directories because
     the information they're looking for isn't displayed on the current
     page (either because it has been deleted, or because a search
     engine took them to the wrong page).

     When you use another web browser, you usually need to remove the
     last component from the URL by using the <DEL> key, etc. several
     times manually.  In emacs-w3m, this operation can be performed in
     only one keystroke, by typing `^'!

<SPC>
     Scroll up or go to next url.  (TODO)

<DEL>
     Scroll down or go to previous url.  (TODO)

Toggle displaying inline images
===============================

If the Emacs version you're using is capable of displaying images in
buffers, then emacs-w3m can display them in web pages, just like
"graphical" browsers like Netscape do.  You should make sure your Emacs
is correctly setup for images before trying to use any of the following
commands (see Required Emacs Version).

   To toggle displaying of images in the current buffer, use `T'.  It
makes emacs-w3m fetch the images from the server, then display them in
the buffer, at the position they would have in a "graphical" browser.
If you hit the key again, images will disappear from the buffer.

   By default, emacs-w3m won't display images, but you can change its
behavior and choose to always display images, for this you need to
customize the `w3m-default-display-inline-images' variable and change
its value from `nil' to `t'.  See Customizable Variables.

   Emacs-w3m also comes with nifty features that let you zoom an image
in or out, save it to a file, or view it in a external viewer.  See also
Moving in a page for instructions on how to move from image to
image in an emacs-w3m buffer.

`T'
     Toggle displaying of inline images in this buffer and buffers
     created from this buffer, later on (`w3m-toggle-inline-images').

`I'
     View the image under point in an external viewer
     (`w3m-view-image').

`M-i'
     Save the image under point to an external file.  The default name
     will be the original name of the image, so most of the time `M-i
     RET' will save the image with the right name (`w3m-save-image').

`M-['
     Zoom out the image under point (`w3m-zoom-out-image').

`M-]'
     Zoom in the image under point (`w3m-zoom-in-image').

Going back through time and space
=================================

Emacs-w3m has several ways to present you with a list of all the pages
you visited before.  The first way is simply called the "emacs-w3m
history", it is a list of the pages you visited in this session,
presented hierarchically, that is: when you follow a link, the page
you're leaving becomes the "parent" of the page you're going to.  It is
a very nice to keep track of the pages you visited, and remember from
where you came if the history gets too long.

   Here is an example of this feature in action, after a short visit to
the GNU Project's homepage:

     GNU's Not Unix! - the GNU Project and the Free Software Foundation (FSF)
       Philosophy of the GNU Project - Free Software Foundation (FSF)
         GNU Emacs - GNU Project - Free Software Foundation (FSF)
          Order from the Free Software Foundation (FSF)
       Links to Other Free Software Sites - GNU Project - Free Software Fo...
         EFF: Homepage

   (In fact, this example is slightly edited to fit in 72 columns; the
URLs won't be cut in the actual emacs-w3m buffer.)

   You can get this kind of history using the `s' key in any emacs-w3m
buffer.

   Please note that this history is buffer-local, i.e. specific to an
emacs-w3m buffer.  But emacs-w3m has a unique feature: when you visit a
new page, the history is copied over to the new buffer, so that you can
still access the pages you visited so far.  This is different from the
way Mozilla and others work; in these browsers the history always starts
from scratch in new buffers.

   The other way to have information about past pages is the "arrived
URLs" list: it is a list of the last 500 URLs you have visited in
emacs-w3m.  The list is ordered by date, the most recent coming first,
and for each page the time of visit is displayed.  Here's an example
(edited):

     Order from the Free Software Foundation (FSF)             22:53:25
     GNU Emacs - GNU Project - Free Software Foundation (FS    22:53:05
     Philosophy of the GNU Project - Free Software Foundati... 22:52:46
     Philosophy of the GNU Project - Free Software Foundati... 22:52:39
     EFF: Homepage                                             22:52:18
     Links to Other Free Software Sites - GNU Project - Fre... 22:52:07
     Links to Other Free Software Sites - GNU Project - Fre... 22:52:07
     GNU's Not Unix! - the GNU Project and the Free Softwar... 22:51:32
     Bookmarks                                                 22:51:02
     The DICT Development Group- upwards                       2003-01-08
     the monkey puzzle: new debian packages as an rss feed     2003-01-08
     new-debian-packages.rss                                   2003-01-07
     it's a miracle                                            2003-01-06

   You can get this history by passing a prefix argument to the previous
command, i.e. using `C-u s'.  The number of URLs showed in this page is
customizable, see the `w3m-keep-arrived-urls' variable.  It cannot
exceed 500 by default.  See Customizable Variables.

   Of course, in all cases all the lines showed in the examples are
links, you can go to any of the pages you visited previously just like
if you were visiting a regular page, by following the link.

`s'
     Display the list of URLs visited in this session.  If called with a
     prefix argument, show the list of arrived URLs instead
     (`w3m-history').

   Also see the Moving over pages section, it explains how to
move in the history with simple keybindings, i.e. the "Back" and "Next"
feature.

That's a favorite with me!
==========================

Like all modern browsers, emacs-w3m has advanced features related to
bookmarks: it lets you classify them in categories, edit them and of
course, browse them easily.

Adding a URL to your favorites
------------------------------

There are several ways to add a URL to your bookmarks.  The first one is
to use the `a' key (or call the `w3m-bookmark-add-current-url' command)
to add the page you're currently browsing: it will prompt you for a
section to where the bookmark should go (completion is available with
the <TAB> key) and will let you edit the title of the bookmark (the
default being the title of the current page).  Complete these two
steps, validating each with `RET', and you will see the message "Added"
in the minibuffer, which means (surprise!) that the page has been added
to your bookmarks.

   Another way to add a bookmark is to use the `M-a' key (or call the
`w3m-bookmark-add-this-url' command): it adds the URL under point (that
means, the URL you would be taken to if you followed the link) to the
bookmarks.  As before, you will have to input the section for this
bookmark and its title, the default being this time the name of the
link itself.

   The third and final way to do this is to use `C-u a', this time you
will be prompted for the URL to add, its section, and the title to use
for it in the bookmarks.

`a'
     Add the current page to the bookmarks, or if called with a prefix
     argument, prompt for a URL and add it
     (`w3m-bookmark-add-current-url').

`M-a'
     Add the URL under point to the bookmarks
     (`w3m-bookmark-add-this-url').

Browse your bookmarks
---------------------

The easiest way to see the bookmarks is to use the `v' key in an
emacs-w3m buffer; another possibility is to go to the special URL
`about://bookmark/'.  You will see your bookmarks, organized by
section, each line being one bookmark.  You can browse them exactly
like you would browse any other page.

`v'
     Visit the bookmarks page (`w3m-bookmark-view').

How to change your bookmarks
----------------------------

Bookmarks are kept in an HTML file, so you can edit the file by hand,
but be very careful: if you erase the comments emacs-w3m needs to
recognize section names, things can break easily.  If you know the
basics of HTML, the file should otherwise be quite self-explanatory.

`E'
     Edit the local file displayed in this
     buffer(`w3m-edit-current-url').

Everybody likes tabs
====================

Unlike most other text-based browsers, emacs-w3m has support for tabbed
browsing(1).  What is tabbed browsing, you might ask?  It's very simple:
it is a way to represent all active emacs-w3m buffers in a single
window, by showing a line at the top which shows all the buffers in a
simple and self-explaining way, each buffer being shown as a "tab".
This line stays visible all the time and does not scroll with the rest
of the buffer, so that you can switch to another buffer, or use the
feedback it provides at any moment.

   The easiest way to get the feeling of it is to just try, so go on and
open an emacs-w3m session.  If you didn't change anything to the
configuration, the tabs line is active by default, it is this bright
line at the top with a smaller rectangle that shows the title of the
current page.  Now create another w3m buffer (with `G', for example):
now you have two of these rectangles.  These are tabs.

   The most obvious use of tabs is switching: by clicking with the
`mouse-1' button on a tab, you make the buffer it represents active.
It also works with the `mouse-2' button.  It's a very quick and easy
way to work with several emacs-w3m buffers, you just have to point and
click.

   Another nifty feature is the feedback it provides.  If you are on a
color terminal or window system, emacs-w3m shows the text in the tab in
different colors to show the status of the page(2).  For example, when
the page is being loaded, the text is in red, and goes back to its
default color (usually black) when the loading is complete.  This way
you can tell with a single glance at the tabs line if the page you're
waiting for has arrived or not.

   Finally, if the web page provides a favicon, it will be shown in the
tab as well(3).  More eye-candy for the emacs-w3m user!

   User options:

`w3m-use-tab'
     Whether to activate tabbed browsing or not.

   ---------- Footnotes ----------

   (1) It's nobody's fault but Emacs 19 or 20 users cannot use tabs.

   (2) Although XEmacs shows all tabs in the same colors at every
moment, you can easily distinguish the selected tab and others and see
the status of the current page in the modeline.

   (3) Under XEmacs, favicons will currently not be shown in the tabs
line.

Creating, killing and moving across buffers
===========================================

Sooner or later, you will be addicted to emacs-w3m, and you'll have to
manage all your browsing needs with it.  To help you with this daunting
task, we have imagined many different ways to work with emacs-w3m
buffers.

Creating and killing buffers
----------------------------

It is sometimes useful to create a new buffer without opening a new web
page in it.  This operation is called "creating a twin copy" of a
buffer, in emacs-w3m lingo.  It will simply create a new buffer whose
contents are identical to the currently active buffer.

   The opposite of this is closing buffers: you can just close one
buffer (because you're not interested in its contents anymore) or you
can decide to close all buffers but the current one.  Emacs-w3m lets
you do this with the following commands:

`C-c C-t'
     Create an identical copy of the currently active buffer, under a
     new name.  This is used to start a new session without loading a
     web page in the new buffer (`w3m-copy-buffer').

`C-c C-w'
     Close the current emacs-w3m buffer (`w3m-delete-buffer').

`C-c M-w'
     Close all emacs-w3m buffers, but the active one
     (`w3m-delete-other-buffers').

Moving across buffers
---------------------

The commands you will probably use most often are those who allow you
to go to an adjacent buffer; that is a buffer just "after" or "before"
the current one.  The meaning of this will be obvious if you use tabs:
the next buffer is the one just after the active one, on the right, and
the previous buffer is the one on the left.  However, XEmacs displays
tabs in random order unfortunately, so you need to pay attention to the
number which is displayed in each tab in order to know what is the
adjacent buffer if you are using XEmacs.  The key bindings for these
commands are `C-c C-p' and `C-c C-n'.

   These commands understand the numeric argument convention, i.e. if
you call them with a number N as argument, you will be taken N buffers
away from the current one.  For example, to go two buffers on the right
from the current position, use `2 C-c C-n'(1).

`C-c C-p'
     Move to the previous emacs-w3m buffer.  This is usually the next
     buffer to the left in the tabs line under Emacs 21.  If called
     with a numeric argument N, move N buffers to the previous
     (`w3m-previous-buffer').

`C-c C-n'
     Move to the next emacs-w3m buffer.  This is usually the next
     buffer to the right in the tabs line under Emacs 21.  If called
     with a numeric argument N, move N buffers to the next
     (`w3m-next-buffer').

   Also note that if these commands don't fit you well despite our
efforts, you might find what you need in "generalist" buffer management
packages such as ibuffer or iswitchb--since emacs-w3m buffers are
regular Emacs buffers, they will work fine too.

   ---------- Footnotes ----------

   (1) You can use `C-u 2 C-c C-n' instead of `2 C-c C-n' as usual.
But keep in mind all numeric keys and minus-sign are assigned to the
numeric prefix arguments in emacs-w3m buffers.

Selecting buffers from a list
-----------------------------

There are two ways to select emacs-w3m buffers from a list.  The first
one is a minibuffer-based interface, called with `C-c C-a'.  You can
choose the buffer you want to display using the `M-p' and `M-n' keys
(or the "up" and "down" arrow keys), they will make you cycle through
the list.  You can also edit the prompt and type the title of an
existing web page, using `TAB' for completion.  For example, if you
have a "Google Search" page opened, you can type "Goo" then hit `TAB'
and the page title will be completed.  After the page name, the buffer
name is given (between brackets).  Then use `RET' to switch to the
buffer you have chosen.

   The second and more sophisticated interface is called the emacs-w3m
buffer list, it is invoked with `C-c C-s'.  It shows you the list of
all opened buffers in a separate window (either a vertical or a
horizontal window--`C-c C-s' toggles between the two modes) and allows
you to view the buffers in real-time: when you move the point in the
buffer list, the buffer under point is displayed in the main window,
which allows you to have direct visual feedback of the buffer you're
switching to.

   To move in the buffer list, you can use the `p' and `n' keys (or the
arrow keys).  In the buffer list, `DEL' and `SPC' allow you to scroll
the buffer displayed in the main window, which is handy if you want to
check that you're seeing the right buffer.  To select the buffer under
point, you can use the `RET' key, in which case the buffer list will be
buried, or the `w' key, in which case the buffer list will remain
visible and the focus given to the main window.

   You can also close and create buffers from this menu, using the same
bindings as the one used in regular buffers (see Creating and killing buffers).

   Finally, the `?' key shows a short help, `g' refreshes the list and
the `q' key exits the buffer list, not changing the active buffer.

`C-c C-a'
     Prompt for a buffer name in the minibuffer.  `M-p' and `M-n' cycle
     through the list of existing buffers and `TAB' completes
     (`w3m-switch-buffer').

`C-c C-s'
     Show the buffer list in a separate window (`w3m-select-buffer').
     In this window, `C-c C-s' toggles between horizontal and vertical
     modes, `RET' selects the buffer under point and buries the buffer
     list, `w' selects the buffer under point and gives it the focus,
     `n', `p' and the arrow keys can be used to move down or up.

Downloading a file
==================

It is possible to download (i.e. fetch, but not display) any web page or
file with emacs-w3m: just put the point on the link you want to
download and hit `d'.  You will be prompted for a filename under which
to save the file locally, by default it will be the name of the file on
the remote server.  Confirm with `RET'.  The download will be
asynchronous and not block your Emacs session, you can continue your
emacs-w3m browsing in another buffer if you want.

   Please note that this download mechanism uses w3m to download things,
you might want to use the more powerful wget downloader instead.  Have a
look at our friend project "emacs-wget", its homepage is at
`http://pop-club.hp.infoseek.co.jp/emacs/emacs-wget/'.

`d'
     Download the file or page pointed by the link under point
     (`w3m-download-this-url').

Filling in HTML forms
=====================

These emacs-w3m commands let you move between forms and fill in fields,
using simple key bindings and optionally prompting you for values in
Emacs windows or in the minibuffer.

   The main key binding to remember is `RET'.  It has different
meanings, depending on the thing under point: for textareas, you will be
prompted for a value in the minibuffer.  For select tags, you will be
given a list of choices in an electric Emacs window (you can move using
the arrow keys, and pick one with the `RET' key).  For radio and
checkbox buttons, the `RET' key selects one of the elements.

   When in the minibuffer or in the electric window, you can cancel with
the `C-c C-q' sequence.  To submit the form, use `C-c C-c'.

`]'
     Jump to the next form (`w3m-next-form').

`['
     Jump to the previous form (`w3m-previous-form').

`C-c C-c'
     Submit form at point (`w3m-submit-form').

`RET'
     Edit the value of the form item under point.

`RET (w3m-form-*-keymap)'
     Accept the value.

`C-c C-q (w3m-form-*-keymap)'
     Quit editing the form item, leaving changes.

Pretty good features
********************

Convenient ways to search the web
=================================

Emacs-w3m comes with advanced features related to search engines, they
are accessible through two interfaces:

   * The regular interface, invoked by the `S' key in any emacs-w3m
     buffer.  It is a simple interactive way to choose which search
     engine to use and input a search term; see The Search Interface.

   * The Quicksearch interface: it is a faster (yet more complicated)
     way to use search engines, by going to specially crafted URLs.
     For more information about this feature, see Quick Searching.

How to search with emacs-w3m
----------------------------

You can fire up the regular search interface by using the `S' key in an
emacs-w3m buffer (provided you use the default keymap).  You will see a
prompt in the minibuffer, asking for a search term.  Type one or
several words at the prompt, then hit `RET'.  The result page of your
search in the engine appears, you can then browse the results, just as
if you had used the normal web based entry point to the engine.

   You probably noticed that you have not been given a chance to choose
which engine you want to search with.  By default, emacs-w3m will use
the Google search engine, you can change this behavior by customizing
the `w3m-search-default-engine' variable (see Customizable Variables),
or you can specify the search engine each time you use the
command.

   To specify which engine to use, you have to give the command a prefix
argument (usually, this means hitting `C-u' before the command, e.g.
`C-u S').  Emacs-w3m will prompt you for an engine, you can choose one
by typing its name (completion is also available with the <TAB> key).
Once you have made your choice, hit the `RET' key.  You can then type
your search term, hit `RET', and you will see the search results.

`S'
     Begin a new search.  If called with a prefix argument, prompt for
     the engine to use (`w3m-search').

An alternative (and fast) way to search the web
-----------------------------------------------

If you're a "Web Power User" (and since you're reading this, you
probably are), you need a quick and efficient way to perform searches.
The Quick Searching feature is one.

   What does it do?  It lets you launch web searches by simply going to
a special URL such as `gg:emacs'.  The advantages of this mode of
operation are:

   * It's fast.  You just have to type a URL to choose the engine and
     the search word(s), in one go.

   * It's convenient.  With this feature, you can easily open a new
     emacs-w3m tab or window, and launch a search in it, using for
     example, the `G' key to open a URL in a new window, and going to a
     Quicksearch URL.  You can also bookmark searches just by
     bookmarking the special Quicksearch URL.

   * It works with the grouping feature.  You can launch two searches
     at the same time, with a URL like `group:gg:emacs&ya:w3m'.  This
     would for instance launch a search for "emacs" on Google and for
     "w3m" on Yahoo!.  See Grouping URLs.

   Using it is very simple: suppose you want to search for the word
"gnu" on Google.  Hit `g' to go to a new URL, and type "gg:gnu".  The
first part of this expression, "gg" indicates that we want to use the
Google search engine.  The second term is the word we will be searching
for.  The prefix and the search term must be separated by a colon.  Hit
`RET', and you will see the results of your search.  Please note that
you can input several words by separating them with spaces (to type a
space in the minibuffer, hit `C-q' first, e.g. `C-q <SPC>').

   The default configuration of emacs-w3m includes several prefixes you
can use, they are defined in the `w3m-uri-replace-alist' variable.
There's for example "gg" for Google, "ggg" for Google Groups, "ya" for
Yahoo!, "al" for Altavista, to name a few.  You can also add prefixes
for the search engines you define, see Adding New Search Engines.

   Instead of prefixes, you can also use full engine names in
Quicksearch URLs, such as "google" or "yahoo".  These names are defined
in the `w3m-search-engine-alist' variable.

Using your favorite engines
---------------------------

Emacs-w3m has a number of built-in search engines you can use.  What if
you want to use your favorite search engine and it's not listed in the
known search engines?  You have to add it to the list of search
engines, and it's quite easy:

  1. First, you have to find what's the entry point of the search
     engine you want to add, for example:

     `http://my.searchengine.com/?query=foobar'

     where foobar is the term you want to search for.

  2. Once you have this information, add this to your `~/.emacs-w3m'
     file:

          (eval-after-load "w3m-search"
            '(add-to-list 'w3m-search-engine-alist
                          '("My engine"
                            "http://my.searchengine.com/?query=%s"
                            nil)))

     Replace the first field "My engine" with the description of your
     engine, the second field with the entry point (the `%s' is
     important, it will be replaced by the search term when you issue
     the search), and the third field is the encoding to use, `nil' or
     omitting this field means to use the value of
     `w3m-default-coding-system' as a regular encoding.

     For English search engines, you rarely have to worry about this.
     However, for some Japanese search engines, you may need to specify
     something (e.g. `euc-japan') there.

  3. You can now use this engine to search, using the normal `S' key in
     emacs-w3m.  If you use this engine often, you can also add it to
     the Quicksearch (see Quick Searching) engines and give it
     a small prefix, by adding this to your `~/.emacs-w3m' file instead:

          (eval-after-load "w3m-search"
            '(progn
               (add-to-list 'w3m-search-engine-alist
                            '("My engine"
                              "http://my.searchengine.com/?query=%s"
                              nil))
               (add-to-list 'w3m-uri-replace-alist
                            '("\\`my:" w3m-search-uri-replace "My engine"))))

     This way you can also use a URL like `my:foobar' to search for the
     term "foobar" with your engine.

Visiting several web pages in one URL
=====================================

Emacs-w3m can manipulate "group URLs": special URLs that contain
several real URLs.  When you open these group URLs, emacs-w3m will open
one buffer for each URL in the group, allowing you to open several pages
in one go.

   To build group URLs, you just have to put together (i.e. concatenate)
all the addresses you want to open, separating them with the ampersand
symbol (that's "&"), and prefixing the grouped URLs with "group:".  For
example, suppose you want to visit the GNU Project's homepage,
`http://www.gnu.org/', and the Savannah homepage,
`http://savannah.nongnu.org/': the group URL would be

   `group:http://www.gnu.org/&http://savannah.nongnu.org/'

   Since this syntax can be quite hard to use on a daily basis, this
feature will be most useful when used with very short URLs (Quicksearch
URLs for example, see Quick Searching); or in non-interactive
contexts.

It will be fine tomorrow
========================

Raise your antenna
==================

Antenna is a tool to keep track of changes in web pages.  Using Antenna,
you can periodically check if particular pages have been updated, and if
they haven't, know the last time you saw them.

   You can start Antenna using the `A' key in any emacs-w3m buffer.
Alternatively, you can go to the special URL `about://antenna/'; it
does the same thing.

How to add your web sites to Antenna
------------------------------------

(Under construction)

   Set information of your favorite sites to `w3m-antenna-sites'.

Tracking changes with Antenna
-----------------------------

On the Antenna page, you will see two sections: one called "Updated"
and another called "Visited".  In the "Updated" section, you will find
websites which have changed since the last Antenna update, and in the
"Visited" section, the websites which haven't.  In each section, each
line stands for one website of the Antenna database, and has the
following structure:

   `  * 2002/12/15 16:43  (T)  My website'

   The first part is the last time the website was updated, or if this
information is not available, the last time Antenna noticed a change in
this page.

   The `(T)' stands for "Time", it means that the change was detected
because the last modification time of that page has changed since the
last Antenna update.  Another possible value here is `S' (for "Size"),
which means that the change has been detected because the size of the
page has changed.

   The last part of this line is the title you gave to this website when
you added it to the database.

   Please note that the Antenna database doesn't get automatically
updated, you have to update it each time you want to check if the sites
have changed, either by hitting `R' in the Antenna page, or by passing a
prefix argument to the command (start Antenna with `C-u A', for
example).

`A'
     Visit the Antenna page.  If called with a prefix argument, update
     the Antenna database before displaying it (`w3m-antenna').

Showing the tree structure of local directory
=============================================

Using the `w3m-dtree' command, you can display a tree of all
subdirectories of a local directory, and browse it like a regular web
page.  The emacs-w3m buffer you get when you use this feature is very
similar to the output of the external "tree" utility, hence the name.
Emacs-w3m adds a bonus: if you call the command with a prefix argument,
it will display files as well, turning emacs-w3m into a full-featured
file browser.

   Here is an example of what an emacs-w3m dtree run looks like:

     /home/romain/.elisp/emacs-w3m/
      |-CVS/
      |-attic/
      |  +-CVS/
      |-autom4te.cache/
      |-doc/
      |  |-CVS/
      |  +-emacs-w3m/
      |-icons/
      |  +-CVS/
      |-patches/
      |  +-CVS/
      +-shimbun/
         +-CVS/

   And with a prefix argument, you get something like this instead:

     /home/romain/.elisp/emacs-w3m/ (allfiles)
      |-(f).cvsignore
      |-(f)BUGS.ja
      |-(f)COPYING
      |-[d]CVS/
      |  |-(f)Entries
      |  |-(f)Repository
      |  +-(f)Root
      |-(f)ChangeLog
      |-(f)ChangeLog.1
      |-(f)Makefile
      |-(f)Makefile.in
      |-(f)README
      |-(f)README.ja

`D'
     Prompt for a local directory in the minibuffer, then display its
     tree structure.  If called with a prefix argument (e.g. `C-u D'),
     show files in the directories as well (`w3m-dtree').

Viewing perl documents
======================

Searching files with Namazu
===========================

(under translation)

Viewing data in various octal form
==================================

Customizable variables
**********************

A lot of emacs-w3m variables are customizable via the Custom mechanism,
a graphical Emacs interface to define user options.  Custom offers
several methods to define your customizations, you can use for example
`M-x customize-option' for a single option (i.e. an Emacs Lisp
variable) or `M-x customize-group' to see all available options
(including variables and faces) for a "group" and change them; in which
case the group to use is `w3m'.

   Alternatively (if you don't want to use Custom), you can put
arbitrary Emacs Lisp expressions in your emacs-w3m initialization file,
which is `~/.emacs-w3m' by default.  This example:

     (setq w3m-home-page "http://emacs-w3m.namazu.org/")

would set the default homepage to `http://emacs-w3m.namazu.org/'.  The
syntax to use is the same as in your `~/.emacs' file.  See
Init File (emacs).

   Please note that some variables from external modules could be
undefined at the time the `~/.emacs-w3m' file is loaded, thus making
them impossible to modify (of course if you don't care about the default
value, you can override them completely in your `~/.emacs-w3m') file.
The `w3m-uri-replace-alist' variable is a typical example (see Search Variables).

`w3m-init-file'
     When emacs-w3m starts, it will read the `w3m-init-file' file.  The
     default value is `~/.emacs-w3m'.  You probably don't need to change
     this.  This is a normal Emacs Lisp file and can be used to avoid
     cluttering your `~/.emacs' and `site-init' files with emacs-w3m
     stuff.  Emacs-w3m will also check for files with the same names as
     this, but with `.elc' and `.el' extensions (in other words,
     `~/.emacs-w3m.elc', `~/.emacs-w3m.el' and `~/.emacs-w3m', in this
     order).

General variables
=================

Variables related to images
===========================

Variables related to bookmarks
==============================

Variables related to searching the web
======================================

Variables related to weather information
========================================

Variables related to the dtree feature
======================================

Variables related to antenna
============================

Variables related to perldoc
============================

Variables related to namazu
===========================

Variables related to the octet feature
======================================

Other variables
===============

Hooking emacs-w3m into mail/newsreaders
***************************************

This section introduces three Message User Agents (MUAs).  All those
MUAs can display HTML mails properly using emacs-w3m.  You'll find here
HowTo's and some notes about setting up and using emacs-w3m with each
of these MUAs.

   Quick note about the conventions we use: what does `message' mean?
When a Gnus user says `message', it often means a draft of a message to
be sent as mail or news.  However, it is the term used by Mew or
Wanderlust users for received mail.  They use `draft' for the draft of
a message to be sent.  On the other hand, a received message is called
an `article' by Gnus users.

Reading HTML mails in Gnus
==========================

Did you know that Gnus, the Emacs newsreader, supports emacs-w3m?

   Actually, the version of Gnus bundled with Emacs does not support
emacs-w3m (yet).  You'd better use the latest version of Gnus known as
`Gnus v5.10'.  It is available at:

   `ftp://ftp.gnus.org/pub/gnus/gnus.tar.gz'

   Note: if emacs-w3m *is* supported in the Gnus version that comes
with your Emacs distribution, it means either that this documentation is
out-of-date (please report this bug as described in Mailing List),
or that you're using a very old version of emacs-w3m (in which
case you should update it to a newer version).

   * What can you do with emacs-w3m?

     You can convert HTML spam mails to be human-readable using
     emacs-w3m.  Of course, it works for HTML ham (non-spam) mails as
     well, and for both emacs-w3m is probably faster than the default
     converter.  You don't need to perform any additional operation.
     It will simply be displayed.

     On HTML parts of an article buffer, the `w3m-minor-mode' is turned
     on and you can use the same main keys as the keys of emacs-w3m, for
     instance, <RET> is for visiting a page which a link in the current
     position points to.  Those keys are defined in the
     `w3m-minor-mode-command-alist' variable.  Keep in mind that some
     commands are replaced by others similar to them, for security
     reasons (see below).

   * What do you have to do?

     Read the Gnus manual (see Display Customization (emacs-mime)).
     The easiest way is to put the following line in your `~/.gnus.el'
     file:

          (setq mm-text-html-renderer 'w3m)

     If you don't need to use emacs-w3m keys in article buffers, add the
     following line too:

          (setq mm-inline-text-html-with-w3m-keymap nil)

   * Notes

     The above description about spam and ham is not for kidding, it's
     just here to get your attention.  Some HTML mails might contain a
     nasty trick used by spammers, using the `<img>' tag which is far
     more evil than the `Click Here!' button.  It is most likely
     intended to check whether the ominous spam mail has reached your
     eyes or not, in which case the spammer knows for sure that your
     email address is valid.  It is done by embedding an identifier
     string into a URL that you might automatically retrieve when
     displaying the image.  By default, the
     `mm-inline-text-html-with-images' variable is `nil' and Gnus will
     never connect to the spammer's site arbitrarily.

     You can display images inline in an article buffer if you set
     `mm-inline-text-html-with-images' to `t', can't you?  No, not
     exactly: you're still being protected.  If you don't care about
     leaking information (i.e. the fact that your mail address is
     reachable), set the `mm-w3m-safe-url-regexp' variable to `nil'.
     The default value for `mm-w3m-safe-url-regexp' is `"\\`cid:"'
     which means we consider that images included in a mail with the
     `cid:' URL are safe (that is, you can display such images without
     modifying the `mm-w3m-safe-url-regexp' variable).

   See also Nnshimbun.

Reading HTML mails in Mew
=========================

By using emacs-w3m with Mew, you can see HTML mails as it intended to be
displayed.  To do so, put the following line in the `~/.mew.el' file:

     (require 'mew-w3m)

With just this, an HTML mail will be displayed in the message window as
if it were a plain text.  You can still use the `C-c C-e' command
(`mew-summary-execute-external') there.

   It is also quite common these days to see mails containing the same
information twice, they use the `multipart/alternative' format which
consists of both a `text/plain' part and a `text/html' part (what a
waste of bandwidth it is).  Mew displays only the `text/plain' part of
such a mail by default.  However, you perhaps want to see the
`text/html' part since you are using emacs-w3m.  If so, add the
following lines to the `~/.mew.el' file:

     (setq mew-mime-multipart-alternative-list
           '("Text/Html" "Text/Plain" ".*"))

   There are some customizable variables related to Mew:

`mew-use-w3m-minor-mode'
     If non-`nil', the `w3m-minor-mode' is turned on in the message
     buffer where a text/html part is displayed, and you can use the
     same main keys as the keys of emacs-w3m, for instance, <RET> is for
     visiting a page which a link in the current position points to.
     Those keys are defined in the `w3m-minor-mode-command-alist'
     variable.  Keep in mind that some commands are replaced by others
     similar to them, for security reasons.  The default value is `nil'.

`mew-w3m-auto-insert-image'
     If non-`nil', you can see images inline in the message buffer when
     you read a multipart/related message.  Note that mew-w3m only
     allows images contained in the message body with a `cid:' URL to be
     displayed (as we consider them safe).  The default value is `nil'.

`mew-w3m-cid-retrieve-hook'
     A hook run just after retrieving a `cid:' URL.  The default value
     is `nil'.

   See also Mew Shimbun.

Reading HTML mails in SEMI MUAs
===============================

You can display HTML mails as human-readable, using emacs-w3m and SEMI
MUAs, for example, Wanderlust, T-gnus, etc.  Since those MUAs depend on
SEMI (and also FLIM) for MIME functions, we generically call them SEMI
MUAs.  Although SEMI uses Emacs/W3 for rendering HTML mails by default,
it can easily be altered to emacs-w3m and it will make your cyber life
still more comfortable.

   You simply need to put the following line in `~/.emacs' file:

     (require 'mime-w3m)

   The `mime-w3m' and `mime-w3' modules are functionally alike, as you
might have guessed (see how the names sound alike?).  The latter is
included in the SEMI package.

   On HTML parts of an article buffer, the `w3m-minor-mode' is turned
on and you can use the same main keys as the keys of emacs-w3m, for
instance, <RET> is for visiting a page which a link in the current
position points to.  Those keys are defined in the
`w3m-minor-mode-command-alist' variable.  Keep in mind that some
commands are replaced by others similar to them, for security reasons.

   There are some customizable variables related to the `mime-w3m'
module:

`mime-w3m-display-inline-images'
     If it is non-`nil', images will be displayed inline in HTML mails.
     If it is the symbol `default' (which is the default) at the first
     time, the value of this variable will be replaced with the value
     of the `w3m-default-display-inline-images' variable.  You probably
     don't need to change this.

`mime-w3m-safe-url-regexp'
     Regexp matching URLs which are considered to be safe.  The default
     value is `"\\`cid:"' which means we consider that images included
     in a mail with the `cid:' URLs are safe.  See also Gnus
     about rogue attacks.

`mime-w3m-setup-hook'
     A hook run just after setting up the cooperation of the `mime-w3m'
     module and SEMI.  The default value is `nil'.

   See also Nnshimbun if you are using T-gnus or Nana-gnus.

There isn't always an answer
****************************

General Questions
=================

   * Q. What's emacs-w3m?

     It is an interface program on Emacs which controls w3m.  For more
     information, see Introduction.

   * Q. Which emacs versions are supported?

     The following Emacsen have been checked for emacs-w3m support:

        * Mule 2.3 (based on Emacs 19.34)

        * Emacs 19.34

        * Emacs 20

        * Emacs 21

        * XEmacs 21.1 with Mule

        * XEmacs 21.2 with Mule (beta37 or greater)

        * XEmacs 21.4 with/without Mule

        * XEmacs 21.5 with/without Mule

        * Meadow

     Note that you're required to use APEL if you'd like to run
     emacs-w3m under Mule 2.3, Emacs 19.34 or XEmacs.  For more
     information, see Other Requirements.

     Emacs-w3m works on Emacs 19.34 or XEmacs without the Mule feature
     except for several commands, such as the command to look weather
     forecasts in Japan.  They strongly depends on the Mule feature, so
     that they must not work on Emacs 19.34 or XEmacs without Mule.

   * Q. Which w3m versions are supported?

     The following w3m versions have been checked for emacs-w3m support:

        * w3m-0.3 and later

        * w3mmee-p23-2

   * Q. I've already installed APEL in the XEmacs SUMO package, is it
     ok?

     There are some problems in the XEmacs APEL package (all modules
     have been compiled for XEmacs with Mule); for instance, the
     `std11' modules conflict with the FLIM's one, etc.  Even though
     you can use `apel-1.23-pkg.tar.gz' or later for both XEmacs with
     Mule and non-Mule XEmacs if you don't use FLIM for the `shimbun'
     features, we recommend you replace it or newly install the
     original APEL package.  See Other Requirements where to
     get it from.

   * Q. I've gotten the developing version of emacs-w3m with CVS,
     however I'm missing `configure' script.

     It is necessary to run `autoconf' first, to generate `configure'
     script.

Troubleshooting
===============

   * Q. Why can't I enter a password on pages which require
     authentication?

     Make sure the `w3m-async-exec' variable is set to a value other
     than `nil'.

   * Q. Why can't I enter a password for a proxy server which requires
     authentication?

     Make sure the `w3m-async-exec' variable is set to a value other
     than `nil'.

   * Q. Why can't I follow links?

     Emacs-w3m requires a version of w3m which recognizes the `-header'
     option.  Check what version of w3m you use.

   * Q. Why do garbage characters appear?

     It could be caused by the following reasons:

       1. Bad HTML file

          If the character set specified by the `<meta>' tag differs
          from the actual contents in an HTML file, it will not be
          displayed correctly.  Use the command `M-x
          w3m-redisplay-with-charset' or `C c' to set the correct
          character set and to force redisplay of the page.

       2. Limitation of the character sets

          A page written by a character set other than
          ISO-2022-JP(jis), EUC-JP, or SHIFT_JIS may not be displayed
          correctly.  Try one of the following ways:

            a. Any characters defined in Unicode will be displayed
               correctly if you install the Mule-UCS package (see
               Other Requirements).  You need to make sure that the
               value of the `w3m-use-mule-ucs' variable is set to a
               value other than `nil' after installing the Mule-UCS
               package.  In addition, if you want to make Emacs (and
               also emacs-w3m) handle the character sets EUC-JISX0213
               and ISO-2022-JP-3, you have to install the `jisx0213'
               module which is contained in the Mule-UCS package
               (though it doesn't work under XEmacs unfortunately).

            b. Install w3mmee or w3m-m17n, and set the `w3m-command'
               variable to the appropriate value.  And emacs-w3m will
               use the multi-lingual features provided by one of those
               programs.

       3. Emacsen incompatibility

          Under XEmacs 21.1, pages written by the SHIFT_JIS character
          set may not be displaied correctly.  There is also a problem
          in XEmacs 21.2 prior to the beta 36 version.  You should
          upgrade your XEmacs if you use such one.

          You should notice that XEmacs versions 21.1 and 21.2 have
          already been retired officially.

   * Q. Why can't images be shown?

     It could be caused by the following reasons:

     There is a bug in the earlier versions of the `libungif' library.
     You have to install `libungif-4.1.0b1' and later.

     You must install the `gifsicle' program if you want to run
     emacs-w3m under XEmacs.  See Other Requirements.

     Emacs-w3m doesn't support the old versions of w3m.  Check what
     version of w3m you use.

   * Q. Why can't I browse pages which require cookies?

     (This is still an experimental feature.)

     Make sure the `w3m-use-cookies' variable is set to a value other
     than `nil'.

   * Q. Why can't I fill in the form?

     (This is still an experimental feature.)

     Make sure the `w3m-use-form' variable is set to a value other than
     `nil'.

   * Q. Why can't I submit a form?

     (This is still an experimental feature.)

     Make sure the `w3m-use-form' variable is set to a value other than
     `nil'.  You also need to use a version of w3m which recognizes the
     `-post' option in order to use this function.  Check what version
     of w3m you use.

   * Q. Why are frames not rendered?

     Install w3mmee and put the following line in your `~/.emacs' file:

          (setq w3m-command "w3mmee")

   * Q. Why are favicon images not displayed in the Emacs 21 tab bar?

     Install the `convert' program which is included in ImageMagick.
     It is available from: `http://www.imagemagick.org/'

   * Q. Why does Emacs 21 get locked when a favicon image is going to be
     displayed?

   * Q. My computer accesses the disk drive violently and says `process
     convert exited abnormally with code 10'.  What's the story?

     Do you use an old version of ImageMagick?  As far as we know, it
     happens when you use the `convert' program bundled with
     ImageMagick 5.2.1.  It has been confirmed that the `convert'
     program bundled with ImageMagick 5.4.0-5 (and later) works fine.

     If you don't want to use ImageMagick, or if you can't use its most
     recent version, add the following line in your `~/.emacs-w3m' file:

          (setq w3m-use-favicon nil)

Questions of Shimbun Library
============================

   * Q. Why are the `shimbun' modules not installed?

     Note that the `shimbun' modules (files under the `shimbun/'
     directory) won't be installed if the FLIM package has not been
     installed in your system.

     The `configure' script determines automatically whether the FLIM
     package is installed or not.  If the FLIM package is installed in
     a non-standard directory, the determination fails.  In this case,
     you can use the `--with-addpath' configure option to explicitly
     set the directory name where the FLIM package has been installed.
     Here's an example:

          % ./configure --with-addpath=$HOME/share/emacs/site-lisp/flim

You can surely solve it
***********************

A tool for reading a newspaper
******************************

Shimbun is pronounced "she-n-boon" (but actually vowels shouldn't be
prolonged), it means "newspaper" in Japanese.  The `shimbun' library is
a collection of many modules, but each of them serves no useful purpose
alone.  This section explains three typical `shimbun' applications (two
of which are included in the `shimbun' library) and how to make
`shimbun' modules by yourself (you need to be able to write Emacs Lisp
programs).  All three applications make it possible to fetch
continuously-updating information from web sites around the world and
to read them as if you were reading mail messages.

   More and more newspapers, mailing list archives, bulletin boards, and
individual diaries (hyper nikki system, weblogs or blogs) are open to
the public through the web.  The `shimbun' library currently supports
Asahi Shimbun, Yomiuri On-line, Emacs Devel, XEmacs Beta, mailing lists
for Gnus, Mew, Wanderlust, etc., the Japanese Prime Minister Koizumi's
mail magazine, Slashdot Japan, and a lot of others.

   Note that you need to have installed the FLIM package (and Gnus if
you'd like to use `nnshimbun') before building and installing
emacs-w3m.  The FLIM package requires the APEL package.  You might also
want to see Other Requirements.

Turning Gnus into a web browser!
================================

`Nnshimbun' is a Gnus back end, but it is distributed with emacs-w3m,
not Gnus, exceptionally.  `Nnshimbun' allows you to turn Gnus into an
exceptionally useful web browser.  You can skim through the articles on
a newspaper's web server without having to see all the advertisement.
You can read articles in mailing list archives as if you were
subscribed to the list.  You can also read submissions in bulletin
boards, etc...  Note that if you want to followup, you still need to use
emacs-w3m as Gnus can't post via the web with `nnshimbun'.

   Put the following line in your `~/.gnus.el' file:

     (autoload 'gnus-group-make-shimbun-group "nnshimbun" nil t)

   Note: it isn't necessary if you are using T-gnus.

   See also Gnus for rendering HTML messages with emacs-w3m if
you use Gnus, see SEMI MUAs for T-gnus or Nana-gnus instead.

   The easiest way to get started with `nnshimbun' is to use something
like the following in the Group buffer:

   `M-x gnus-group-make-shimbun-group RET asahi RET national RET'

Replace `asahi' and `national' with the keyword corresponding to the
server you'd like to connect to and the group you're interested in
respectively.  You can complete both of those names by using <TAB> or
<SPC>.

   You can also bind that to a key if there's enough room in the
`gnus-group-mode-map' map, you can add something like the following in
your `~/.gnus.el' file (T-gnus users, you don't need to bother to add
it, since there's already the similar thing in T-gnus):

     (eval-after-load "gnus-group"
       '(define-key gnus-group-mode-map "Gn"
          'gnus-group-make-shimbun-group))

Then, you can use `G n' instead of `M-x gnus-group-make-shimbun-group'.

   _Could someone book this keystroke at the Gnus Tower?_

   `Nnshimbun' simply fetches HTML contents from the web server and
displays them as an article, but it will never save articles in the
local file system, except if you use persistent articles (see
Persistent Articles (gnus)).  `Nnshimbun' uses NOV files for each
`nnshimbun' group, and its back end is almost the same as `nnml'.

   The following `nnshimbun' variables can be customized:

`nnshimbun-keep-backlog'
     This variable overrides the `gnus-keep-backlog' variable (see
     Article Backlog (gnus)) in `nnshimbun' groups.  If you set
     `nnshimbun-keep-backlog' to a number N, `nnshimbun' will store at
     most N old articles in a buffer for later re-fetching.  If this
     variable is non-`nil' and is not a number, `nnshimbun' will store
     _all_ read articles (this is not a good idea).  The default value
     is 300.

     Note that smaller values may spoil the `prefetch-articles' feature
     (see below), since `nnshimbun' uses the backlog to keep the
     prefetched articles.

`nnshimbun-directory'
     Directory where `nnshimbun' saves NOV files.  The default value is
     `~/News/shimbun/'.

   You can use the specially made group parameter for `nnshimbun' in
addition to the standard group parameters provided by Gnus(1).  Several
parameters for `nnshimbun' are collected into the single group parameter
`nnshimbun-group-parameters' which is a property list (the values can
be different for every group).  Here's an example:

     '(index-range all prefetch-articles off encapsulate-images on
                   expiry-wait 6)

   Below is the documentation for those group parameters and related
variables.

`prefetch-articles'
     In a group where this group parameter is set to something else than
     `off' or `nil', `nnshimbun' not only checks for new articles, but
     also downloads them.  Though it will slow checking of new articles
     down, you won't be kept waiting when reading articles.  In the
     group where this group parameter is not set or its value is `nil',
     the value of the `nnshimbun-pre-fetch-article' variable (`off' by
     default) is used instead.

`encapsulate-images'
     In a group where this group parameter is set to something else than
     `off' or `nil', `nnshimbun' will put image data embedded in the
     original contents into an article as `multipart/related' parts of
     the MIME format.  In the group where this group parameter is not
     set or its value is `nil', the value of the
     `nnshimbun-encapsulate-images' variable is used instead.  The
     default value for the `nnshimbun-encapsulate-images' variable is
     the value of the `shimbun-encapsulate-images' variable which is
     provided in the `shimbun' library (the default value is probably
     `t').

`index-range'
     You can specify the range of articles to be fetched from the web
     server using the `index-range' group parameter.  To specify the
     range, use the following values:

    `nil'

    `all'
          all pages

    `last'
          only the latest page

    `integer N'
          the latest N pages

     `Nnshimbun' checks whether there are new articles by parsing the
     index page of the server.  It is possible that there are two or
     more index pages on the server.  For instance, in the case of the
     mailing list servers, index pages are generally classified
     according to the date on which the article was posted.  It would
     take a considerable amount of time to check all those huge index
     pages especially if you are connecting via a slow line.

     If it is possible, `nnshimbun' won't check index pages which have
     already been checked at the last connection.  If you want to save
     even more time, use `last'.  It makes `nnshimbun' refer to only the
     latest index page for checking new articles.

     In the group where the `index-range' group parameter is not set or
     its value is `nil', the value of the `nnshimbun-index-range'
     variable (`nil' by default) is used.

`nnshimbun-group-parameters-alist'
     This is an Emacs Lisp variable, an alist of regexp of group names
     and `nnshimbun' group parameters.  The default value is `nil'.
     Each element may have the form `(REGEXP KEYWORD VALUE KEYWORD
     VALUE...)', for example:

          '("^nnshimbun\\+asahi:" index-range all prefetch-articles off
            encapsulate-images on expiry-wait 6)

     Since you can use this variable to specify the same `nnshimbun'
     group parameters for two or more groups which have similar names
     (i.e., those groups are likely to have similar characteristics
     each other), it is useful that it can be used instead of
     specifying the `nnshimbun' group parameters to several groups
     respectively.  If the group parameter has already been set in a
     group, that takes precedence over this variable.

   You can instruct `nnshimbun' to expire articles(2).  Keep in mind
that when an article is expired, it is not deleted from the remote
server, it's still available there.  What is deleted is the line in
your own NOV file for `nnshimbun'(3) corresponding to the article to be
expired.  Then the article won't appear in the Summary buffer, forever
and ever.

   If you don't expire articles in `nnshimbun' groups, the NOV files
will continue to grow fat indefinitely and you may see very old
articles in the Summary buffer as if they were existing (in fact, they
might have expired three years ago on the remote server!).  Even if you
try to read such an article, nothing will appear in the article buffer.
On the other hand, most mailing list servers generally offer all the
past articles.  You may not feel like expiring articles in such groups
in order to look back with nostalgia to the good old days and to be
able to read, eyes filled with tears, articles which you thought long
gone.

   You can mark `nnshimbun' articles as expirable and specify the
expiry period in each `nnshimbun' group as well as the other mail back
ends.  However, there are a little differences between `nnshimbun' and
the other mail back ends:

   * First of all, the expiry period is determined with the following
     priorities.  Note that the default value might be different from
     group to group.

       1. The value of the `expiry-wait' group parameter in a group.

       2. The value produced by evaluating the
          `nnmail-expiry-wait-function' variable for a group.

       3. The default value provided by the `shimbun' module
          corresponding to a group.

       4. The value of the `nnmail-expiry-wait' variable.

   * Second of all, the argument to be passed to the function specified
     by the `nnmail-expiry-wait-function' variable will contain the
     names of the back end and the server like
     "nnshimbun+asahi:national", while only the group name will be
     given in the case of the other mail back ends.  Here's an example:

          (setq nnmail-expiry-wait-function
                (lambda (group)
                  (cond ((string-equal group "ding") 7)
                        ((string-equal group "nnshimbun+ding:ding") 'never))))

     This means that there are two groups for the same ding mailing
     list; one is subscribed as a list member, the other is for reading
     from the mailing list archive at the Gnus Towers.  Ahem, isn't it
     clever?  The local mail files in the "ding" group will be expired
     in seven days and your local disk space will be saved, but you can
     read even the articles of the last century in the second group (if
     it is really needed, though).

   * Third of all, and this is written down so that you can remember it
     when you're filled with doubt: even when all articles from a
     `nnshimbun' group should be expired, the most recent one will be
     kept.  This is not to satisfy your indecisive heart, it's because
     the next time you fetch new articles for this group, `nnshimbun'
     will know where to begin and not fetch all the articles all over
     again.

   The group parameters and the variables related to expiring
`nnshimbun' articles are:

`expiry-wait'
     Don't be confused, please.  The `expiry-wait' group parameter is
     provided as one of the elements of `nnshimbun-group-parameters',
     the specially made group parameter for `nnshimbun'.  It has the
     same name and the same meaning as the standard group parameter.
     You may use whichever you like.  If nnshimbun's one is set to
     non-`nil' value, it takes precedence over the standard one.  It is
     provided in order to concentrate things related to `nnshimbun' at
     one place of the "Gnus Customize" buffer (which will appear by
     typing `G c' in the group buffer) and to realize managing
     collectively by the `nnshimbun-group-parameters-alist' variable(4).
     The values which can be used are a number of expiry period, `never'
     or `immediate' as well as the standard group parameter.

`nnshimbun-keep-unparsable-dated-articles'
     If this variable is non-`nil', the articles of which the time of
     creation (or the time of arrival) is unknown will never be expired,
     since their age is unknown.  The default is `t'.  If you set this
     variable to `nil', the articles of which the time is unknown will
     also be expired unconditionally when the time to expire has come.
     Well, it might prove useful for a general cleaning at the end of a
     year.

   ---------- Footnotes ----------

   (1) The easiest way to specify group parameters is to type `G c' in
the group buffer after moving the point to the group you'd like to
customize (see Group Parameters (gnus)).

   (2) There are mainly two ways to expire articles automatically in
the `nnshimbun' groups.  One is to add a group name regular expression
(it should begin with "^nnshimbun\\+") to the
`gnus-auto-expirable-newsgroups' variable and to put the expiry period
for each group into the `nnmail-expiry-wait-function' variable.
Another is to set the `auto-expire' group parameter to `t' and to set
the expiry period with the `expiry-wait' group parameter in every
`nnshimbun' group which you want to expire automatically.  See
Expiring Mail (gnus) for more information.  In the group to which the
`expiry-wait' group parameter is not specified, a default expiry period
will be applied.

   (3) The NOV file for `nnshimbun' is named something like
"~/News/shimbun/asahi/national/.overview".

   (4) We've already prepared the answer to the question that why
`auto-expire' etc. aren't included in the nnshimbun's special group
parameter?  The answer is, `expiry-wait' is handled by the `nnshimbun'
back end, but `auto-expire' is handled by the Gnus core.  Therefore, it
is contrary to the design policy of Gnus to extend the Gnus core
functions so that it may work for one particular back end (i.e. reading
a value from the nnshimbun's special group parameter).

Reading web newspapers with Mew
===============================

Mew Shimbun is an Emacs Lisp program meant to be used with `shimbun'
and Mew (version 2.1 and later).  The `mew-shimbun' module will be
installed together with emacs-w3m if Mew, APEL, and FLIM are also
installed.

   We recommend you also see Mew.

  1. Setting things up

     Put the following lines in the last of the `~/.mew.el' file:

     ;;; Loading mew-shimbun, defining keys.
     ;; (setq mew-shimbun-use-unseen t)              ;;; (1)
     (require 'mew-shimbun)
     (define-key mew-summary-mode-map "G"  (make-sparse-keymap))
     (define-key mew-summary-mode-map "Gg" 'mew-shimbun-goto-folder)
     (define-key mew-summary-mode-map "GG" 'mew-shimbun-goto-unseen-folder)
     (define-key mew-summary-mode-map "Gi" 'mew-shimbun-retrieve)
     (define-key mew-summary-mode-map "GI" 'mew-shimbun-retrieve-all)
     (define-key mew-summary-mode-map "Gr" 'mew-shimbun-re-retrieve)
     (define-key mew-summary-mode-map "GR" 'mew-shimbun-re-retrieve-all)
     (define-key mew-summary-mode-map "Ge" 'mew-shimbun-expire)
     (define-key mew-summary-mode-map "GE" 'mew-shimbun-expire-all)

     ;; Specifying `shimbun' servers and groups to be read with Mew in the
     ;; `mew-shimbun-folder-groups' variable.  Each element has the form
     ;; `("folder" ("server.group" . range) ...)'.  You can use `all',
     ;; `last', and a number for the `range' item.

     (setq mew-shimbun-folder-groups
           '(;; Fetching `yomiuri.shakai', `yomiuri.sports', etc.
             ;; into the `+shimbun/yomiuri' folder collectively.
             ("yomiuri"
              ("yomiuri.shakai" . 2)
              ("yomiuri.sports". 2)
              ("yomiuri.kokusai". 2))
             ;; Fetching `security-memo.memo'
             ;; into `+shimbun/security-memo'.
             ("security-memo"
              ("security-memo.memo" . 2))
             ("slashdot-jp"
              ("slashdot-jp.story" . last))
             ;; You can read several groups in one folder (`+shimbun/comp')
             ;; as follows even if each group comes from a different server.
             ("comp"
              ("cnet.comp" . last)
              ("zdnet.comp" . last))
             ;; Fetching diaries into `+shimbun/hns/arisawa' and
             ;; `+shimbun/hns/miyoshi' respectively.
             ("hns/arisawa"
              ("hns.arisawa" . last))
             ("hns/miyoshi"
              ("hns.miyoshi" . last))))

     You did the fundamental setups.  For the other user definable
     variables, use `M-x customize-group' for the `mew-shimbun' group
     or see the source code.

  2. Reading `shimbun' messages

       a. Getting started

          Type `G I' (`mew-shimbun-retrieve-all') first, after setting
          things up as mentioned above.  The `shimbun' folders
          specified by the `mew-shimbun-folder-groups' variable will be
          created under the `+shimbun' parent folder.  Typing `G I' is
          also useful when you have added new groups.  You can change
          the name of the parent folder (`+shimbun' by default) by
          customizing the `mew-shimbun-folder' variable.

       b. Moving into a `shimbun' folder

          You can move to any folder (including `shimbun') by typing `g'
          (`mew-summary-goto-folder'), but `G g'
          (`mew-shimbun-goto-folder') is restricted to moving to only
          the `shimbun' folder.  In addition, folders which have new
          messages (in other words, folders which have not been
          scanned) will be displayed when using a prefix argument with
          `G g' (i.e. `C-u G g').  A prefix argument similarly affects
          `G G' as well.

       c. Fetching messages in each folder

          You can fetch new messages for the current folder exclusively
          by typing `G i' (`mew-shimbun-retrieve') in a `shimbun'
          folder.

       d. Fetching updated messages

          If you perform the `G r' command (`mew-shimbun-re-retrieve')
          when a particular message is being displayed, the message
          will be updated if it is possible, and new messages will be
          fetched.  With a prefix argument (i.e. `C-u G r'), it will
          attempt to update messages which are marked with the mark
          specified by the `mew-shimbun-mark-re-retrieve' variable (`@'
          by default).  It would be useful for CNET, etc.

          The `G R' command (`mew-shimbun-re-retrieve-all') checks the
          freshness of all messages and re-fetches the updated
          messages.  If a prefix argument is given (i.e. `C-u G R'),
          the messages within the region will be processed.  It is
          probably worthwhile if the site is running the hyper nikki
          system (`nikki' means "diary" in Japanese).

  3. Managing unseen messages

     If you have the following setting in the `~/.mew.el' file,

          (setq mew-shimbun-use-unseen t)

     newly fetched messages will be marked with the mark specified by
     the `mew-shimbun-mark-unseen' variable (`*' by default), and it
     will disappear automatically after reading the message.

     Normally, the unseen marks will not be saved in the `.mew-cache'
     file if scanning is not performed after adding or deleting marks
     in the Mew summary mode, but if you add the following line to the
     `~/.mew.el' file,

          (setq mew-shimbun-use-unseen-cache-save t)

     the unseen marks will be saved in the `.mew-cache' file
     automatically for the `shimbun' groups when exiting Mew or killing
     a folder (using `C-c C-q').  However, it is not securely saved
     (2).  To do this securely, you had better have the habit of
     performing the `scan update' command after reading the folder.

     If you don't like the `*' mark for unseen messages, customize the
     `mew-shimbun-mark-unseen' variable (see above).  By specifying the
     mark by `C-u N', you will be able to lead a better life with
     taking care of unseen messages.

  4. Expiring messages

     You can expire messages if you set the `mew-shimbun-expires'
     variable beforehand.  For example:

          (setq mew-shimbun-expires
                '(("yomiuri" . 7)
                  ("asahi" . 1)
                  ("slashdot-jp" . 7)
                  ("comp" . 7)))

     If you set this variable as shown above, you can specify the expiry
     period; 7 days for `+shimbun/yomiuri', 1 day for `+shimbun/asahi'.
     Messages in the `shimbun' folder where the expiry period is not
     specified will never be expired.  You can use the `G e' command
     (`mew-shimbun-expire') to expire the expirable messages in the
     current folder.  The `G E' command (`mew-shimbun-expire-all') is
     for expiring the expirable messages in all the `shimbun' folders.
     Note that once the messages have been expired, you cannot recover
     them.

  5. How to mark messages with `$' as unseen

     Put the following lines in the `~/.mew.el' file in order to define
     the `$' mark and use `$' for the mark of unseen.  See
     `http://www.mew.org/ml/mew-dist-2.0/msg01251.html' if you would
     like to replace the `$' mark with another.

     ;;----------------------------------------------------------------------
     ;;; Code for using `$' as the unseen mark.
     (setq mew-mark-unseen ?$)
     (setq mew-shimbun-mark-unseen mew-mark-unseen)
     (setq mew-mark-show-list (cons mew-mark-unseen mew-mark-show-list))
     (setq mew-mark-afterstep-spec
           (cons (cons mew-mark-unseen '(1 0 1 0 0 0 0))
                 mew-mark-afterstep-spec))
     (setq mew-mark-spec
           (cons (list mew-mark-unseen "unseen" 0 nil nil nil nil nil)
                 mew-mark-spec))
     (setq mew-highlight-mark-keywords
           (cons
            (cons mew-mark-unseen 'mew-face-mark-unseen)
            mew-highlight-mark-keywords))
     (defface mew-face-mark-unseen
       '((((class color) (type tty))
          (:foreground "green"))
         (((class color) (background light))
          (:foreground "deep pink" :bold t :italic t))
         (((class color) (background dark))
          (:foreground "thistle"))
         (t (:bold t)))
       "*Face to highlight the unseen mark"
       :group 'mew-highlight)
     (defun mew-summary-unseen (&optional count)
       "Put the unseen mark(default is '$') in COUNT times."
       (interactive "P")
       (mew-mark-put-mark-loop (function mew-summary-unseen-one) count nil))
     (defun mew-summary-unseen-one (&optional no-msg)
       "Put the unseen mark(default is '$') on this message."
       (mew-mark-put-mark mew-mark-unseen no-msg))
     (defun mew-summary-mark-unseen ()
       "Change the '*' mark into the '$' mark."
       (interactive)
       (mew-summary-exchange-mark mew-mark-review mew-mark-unseen))
     (defun mew-thread-mark-unseen ()
       "Put the '$' mark on all messages of the current sub-thread."
       (interactive)
       (mew-thread-mark mew-mark-unseen))

     (define-key mew-summary-mode-map "$"  'mew-summary-unseen)
     (define-key mew-summary-mode-map "m$" 'mew-summary-mark-unseen)
     (define-key mew-summary-mode-map "t$" 'mew-thread-mark-unseen)
     ;;----------------------------------------------------------------------

   ---------- Footnotes ----------

   (1) Uncomment this line if you'd like to manage unseen messages.  It
must be placed before the `(require 'mew-shimbun)' line.

   (2) People who have set the `mew-touch-folder-p' variable to `t'
will succeed 100% in saving marks, but people who use `nil' value seem
not to be 0% successful.

Reading web newspapers with Wanderlust
======================================

Wanderlust includes `elmo-shimbun' as an ELMO module, so you can read
`shimbun' by just accessing a folder beginning with `@' (see
Shimbun Folder (wl)).

Sites supported by Shimbun
==========================

This section provides the list of sites supported by `shimbun' library.
Unfortunately for people who cannot understand Japanese, almost of
supported sites are written in Japanese.

Newspapers Supported by Shimbun
-------------------------------

These are newspapers that are supported by `shimbun' library.

Asahi Shimbun (http://www.asahi.com/)
     asahi.business asahi.culture asahi.english asahi.international
     asahi.national asahi.politics asahi.science asahi.sports

     These backends generates articles including only texts; in other
     hands, `asahi-html' generates MIME articles that include texts and
     photographs.  In order to use the latter backend, specify
     asahi-html.business instead of asahi.business as the group name.

Mainichi Shimbun (http://www.mainichi.co.jp/)
     mainichi.shakai mainichi.sports mainichi.seiji mainichi.keizai
     mainichi.kokusai mainichi.fuho

Nikkan Sports (http://www.nikkansports.com/)
     nikkansports.baseball nikkansports.mlb nikkansports.soccer
     nikkansports.world-soccer nikkansports.sports nikkansports.battle
     nikkansports.horseracing nikkansports.entertainment
     nikkansports.society nikkansports.leisure

Nihon Keizai Shimbun (http://www.nikkei.co.jp/)
     nikkei.kaigai nikkei.keizai nikkei.main nikkei.market
     nikkei.okuyami nikkei.retto nikkei.sangyo nikkei.seiji
     nikkei.shakai nikkei.shasetsu nikkei.tento nikkei.zinzi

Sponichi (http://www.sponichi.co.jp/)
     sponichi.baseball sponichi.soccer sponichi.usa sponichi.others
     sponichi.society sponichi.entertainment sponichi.horseracing

Yomiuri Shimbun (http://www.yomiuri.co.jp/)
     yomiuri.business yomiuri.editorial yomiuri.national yomiuri.obit
     yomiuri.politics yomiuri.sports yomiuri.world

     The backend, `yomiuri-html', is also supported.

News Sites Supported by Shimbun
-------------------------------

These are news sites that are supported by `shimbun' library.

Japan CNET (http://cnet.sphere.ne.jp/)
     cnet.comp

Impress (http://www.watch.impress.co.jp/)
     impress.internet impress.pc impress.akiba impress.game impress.av
     impress.jijinews impress.sports

Slashdot Japan (http://slashdot.jp/)
     slashdot-jp.story

HotWired Japan (http://www.hotwired.co.jp/)
     wired.business wired.culture wired.technology

Yahoo! Japan (http://headlines.yahoo.co.jp/)
     yahoo.politics yahoo.society yahoo.people yahoo.business-all
     yahoo.market yahoo.stock yahoo.industry yahoo.international
     yahoo.entertainment yahoo.sports yahoo.computer yahoo.hokkaido
     yahoo.tohoku yahoo.kanto yahoo.sinetsu yahoo.hokuriku yahoo.tokai
     yahoo.kinki yahoo.chugoku yahoo.sikoku yahoo.kyushu yahoo.okinawa

ZDNet Japan (http://www.zdnet.co.jp/)
     zdnet.comp zdnet.gamespot

Mailing Lists Supported by Shimbun
----------------------------------

These are mailing list archives supported by `shimbun' library.

Semi-gnus Mailing List in Japan (http://lists.airs.net/semi-gnus/archive/)
     airs.semi-gnus-ja

Wanderlust Mailing List (http://lists.airs.net/)
     airs.wl airs.wl-en

Big Brother DataBase Mailing List (http://www.rc.tutrp.tut.ac.jp/bbdb-ml/)
     bbdb-ml.bbdb-ml

GNOME Mailing List (http://mail.gnome.org/archives/)
     gnome.balsa-list gnome.calendar-list gnome.cvs-commits-list
     gnome.foundation-announce gnome.foundation-list gnome.fplan-list
     gnome.gconf-list gnome.gdome gnome.gnome-1.4-list
     gnome.gnome-announce-list gnome.gnome-components-list
     gnome.gnome-db-list gnome.gnome-de gnome.gnome-debugger-list
     gnome.gnome-devel-list gnome.gnome-doc-list gnome.gnome-gui-list
     gnome.gnome-hackers gnome.gnome-hackers-readonly
     gnome.gnome-hackers-test gnome.gnome-i18n gnome.gnome-i18n-tools
     gnome.gnome-kde-list gnome.gnome-list gnome.gnome-office-list
     gnome.gnome-pilot-list gnome.gnome-sound-list
     gnome.gnome-themes-list gnome.gnome-ui-hackers
     gnome.gnome-web-list gnome.gnome-webmaster-list
     gnome.gnome-workshop-list gnome.gnomecc-list gnome.gnumeric-list
     gnome.gtk-app-devel-list gnome.gtk-devel-list gnome.gtk-doc-list
     gnome.gtk-i18n-list gnome.gtk-list gnome.gtk-perl-list
     gnome.guppi-list gnome.libart gnome.libart-hackers gnome.orbit-list
     gnome.vote gnome.wm-spec-list gnome.xml gnome.xslt

h14m Mailing List (http://www.h14m.org/ml/)
     h14m.hns-dev h14m.hns-users

Java Conference Mailing List (http://www.java-conf.gr.jp/archives/)
     javaconf.servlet-ml javaconf.business-ml
     javaconf.duke-in-the-box-ml javaconf.jfriends-ml javaconf.JGT-ml
     javaconf.jini-ml javaconf.ejb-ml javaconf.cm-ml javaconf.horb-ml
     javaconf.talk-ml

LinuxCE JP Mailing List (http://www.peanuts.gr.jp/~kei/ml-archive/)
     linuxce-jp.users

Mule Mailing List (http://www.m17n.org/)
     m17n.mule-ja m17n.mule

Meadow Mailing List (http://www.ysnb.net/meadow/)
     meadow.meadow-develop meadow.meadow-users-jp

Mew Mailing List (http://www.mew.org/ml/)
     mew.mew-dist mew.mew-win32 mew.mew-int

MagicPoint Mailing List (http://www.mew.org/ml/)
     mew.mgp-users mew.mgp-users-jp

Namazu Mailing List (http://www.namazu.org/ml/)
     namazu.namazu-users-ja namazu.namazu-win32-users-ja
     namazu.namazu-users-en namazu.namazu-devel-ja
     namazu.namazu-devel-en

emacs-w3m Mailing List (http://emacs-w3m.namazu.org/ml/)
     namazu.emacs-w3m

migemo Mailing List (http://migemo.namazu.org/ml/)
     namazu.migemo

NetBSD JP Mailing List (http://www.jp.netbsd.org/ja/JP/ml/)
     netbsd.announce-ja netbsd.junk-ja netbsd.tech-misc-ja
     netbsd.tech-pkg-ja netbsd.port-arm32-ja netbsd.port-hpcmips-ja
     netbsd.port-mac68k-ja netbsd.port-mips-ja netbsd.port-powerpc-ja
     netbsd.hpcmips-changes-ja netbsd.members-ja netbsd.admin-ja
     netbsd.www-changes-ja

QuickML (http://namazu.org/~satoru/archives/)
     quickml.quickml-users quickml.quickml-server quickml.chatty
     quickml.dotnet quickml.linux-zaurus quickml.ming quickml.pdumpfs
     quickml.stationery quickml.tty-mania

Ruby Mailing List (http://blade.nagaokaut.ac.jp/)
     ruby.comp.lang.ruby ruby.fj.comp.lang.ruby ruby.ruby-dev
     ruby.ruby-ext ruby.ruby-list ruby.ruby-math ruby.ruby-talk

Toshiba Linux Users JP Mailing List (http://linux.toshiba-dme.co.jp/ML/tlinux-users-j/)
     toshiba.linux-users-j

w3m-dev Mailing List (http://mi.med.tohoku.ac.jp/~satodai/w3m-dev/)
     w3m-dev.w3m-dev

digiko Mailing List (http://yar-3.net/digiko/)
     digiko.digiko

XEmacs Mailing List (http://list-archive.xemacs.org/)
     xemacs.xemacs-announce xemacs.xemacs-beta-ja xemacs.xemacs-beta
     xemacs.xemacs-build-reports xemacs.xemacs-cvs xemacs.xemacs-design
     xemacs.xemacs-mule xemacs.xemacs-nt xemacs.xemacs-patches
     xemacs.xemacs-users-ja xemacs.xemacs

Security MEMO Mailing List (http://memo.st.ryukoku.ac.jp/archive/)
     security-memo.memo

Debian JP Mailing List (http://lists.debian.or.jp/)
     debian-jp.debian-announce debian-jp.debian-devel
     debian-jp.debian-www debian-jp.debian-users debian-jp.debian-policy
     debian-jp.jp-qa

Debian Mailing List (http://lists.debian.org)
     debian.debian-announce debian.debian-commercial
     debian.debian-firewall debian.debian-french debian.debian-isp
     debian.debian-italian debian.debian-kde debian.debian-laptop
     debian.debian-news debian.debian-news-german
     debian.debian-news-portuguese debian.debian-security-announce
     debian.debian-testing debian.debian-user debian.debian-user-catalan
     debian.debian-user-french debian.debian-user-polish
     debian.debian-user-portuguese debian.debian-user-spanish
     debian.debian-user-swedish debian.debian-admintool
     debian.debian-apache debian.debian-autobuild debian.debian-beowulf
     debian.debian-boot debian.debian-cd debian.debian-ctte
     debian.debian-debbugs debian.debian-devel
     debian.debian-devel-announce debian.debian-devel-french
     debian.debian-devel-games debian.debian-devel-spanish
     debian.debian-doc debian.debian-dpkg debian.debian-emacsen
     debian.debian-events-eu debian.debian-events-na debian.debian-faq
     debian.debian-gcc debian.debian-glibc debian.debian-gtk-gnome
     debian.debian-hams debian.debian-ipv6 debian.debian-java
     debian.debian-jr debian.debian-med debian.debian-mentors
     debian.debian-newmaint debian.debian-newmaint-admin
     debian.debian-ocaml-maint debian.debian-openoffice
     debian.debian-perl debian.debian-pilot debian.debian-policy
     debian.debian-pool debian.debian-python debian.debian-qa
     debian.debian-qa-private debian.debian-release
     debian.debian-security debian.debian-snapshots
     debian.debian-tetex-maint debian.debian-toolchain
     debian.debian-vote debian.debian-wnpp debian.debian-www
     debian.debian-x debian.deity debian.debian-chinese
     debian.debian-chinese-big5 debian.debian-chinese-gb
     debian.debian-esperanto debian.debian-i18n debian.debian-japanese
     debian.debian-l10n-catalan debian.debian-l10n-dutch
     debian.debian-l10n-english debian.debian-l10n-french
     debian.debian-l10n-italian debian.debian-l10n-portuguese
     debian.debian-l10n-spanish debian.debian-laespiral
     debian.debian-russian debian.debian-simplified-chinese
     debian.debian-68k debian.debian-alpha debian.debian-arm
     debian.debian-bsd debian.debian-hppa debian.debian-hurd
     debian.debian-ia64 debian.debian-mips debian.debian-parisc
     debian.debian-powerpc debian.debian-s390 debian.debian-sparc
     debian.debian-superh debian.debian-ultralinux debian.debian-win32
     debian.debian-all-changes debian.debian-alpha-changes
     debian.debian-arm-changes debian.debian-books
     debian.debian-cd-vendors debian.debian-changes
     debian.debian-consultants debian.debian-curiosa
     debian.debian-devel-all-changes debian.debian-devel-alpha-changes
     debian.debian-devel-arm-changes debian.debian-devel-changes
     debian.debian-devel-hurd-i386-changes
     debian.debian-devel-i386-changes debian.debian-devel-m68k-changes
     debian.debian-devel-powerpc-changes
     debian.debian-devel-sparc-changes debian.debian-hurd-i386-changes
     debian.debian-i386-changes debian.debian-legal
     debian.debian-m68k-changes debian.debian-mirrors
     debian.debian-powerpc-changes debian.debian-project
     debian.debian-publicity debian.debian-sgml
     debian.debian-sparc-changes debian.lcs-eng debian.lsb-confcall
     debian.lsb-discuss debian.lsb-impl debian.lsb-spec debian.lsb-test
     debian.spi-announce debian.spi-general debian.vgui-discuss

KDE Mailing List in Japan (http://www.kde.gr.jp/ml/)
     kde.Kuser kde.Kdeveloper

Geocrawler (http://www.geocrawler.com/)
     All archives of Geocrawler are supported by `shimbun' library.  You
     can use the command `M-x shimbun-geocrawler-add-group RET', to add
     your favorite archive to the variable
     `shimbun-geocrawler-group-alist'.

Mailing list ARChives (http://marc.theaimsgroup.com/)
     Mailing list ARChives (MARC) are supported by `shimbun' library.
     Add a group name of your favorite archive and its URL to the
     variable `shimbun-marc-aims-group-alist', and you can browse it.

RedHat Mailing List (http://sources.redhat.com/ml/)
     redhat.automake redhat.bug-automake redhat.automake-prs
     redhat.automake-cvs redhat.binutils redhat.binutils-cvs
     redhat.c++-embedded redhat.crossgcc redhat.cgen redhat.cgen-prs
     redhat.cgen-cvs redhat.cygwin redhat.cygwin-xfree
     redhat.cygwin-announce redhat.cygwin-xfree-announce
     redhat.cygwin-apps redhat.cygwin-patches redhat.cygwin-developers
     redhat.cygwin-cvs redhat.cygwin-apps-cvs
     redhat.docbook-tools-discuss redhat.docbook-tools-announce
     redhat.docbook-tools-cvs redhat.docbook redhat.dssslist
     redhat.sgml-tools redhat.docbook-apps redhat.ecos-announce
     redhat.ecos-devel redhat.ecos-discuss redhat.ecos-maintainers
     redhat.ecos-patches redhat.elix redhat.elix-announce redhat.gdb
     redhat.gdb-announce redhat.gdb-testers redhat.gdb-testresults
     redhat.gdb-patches redhat.gdb-cvs redhat.bug-gdb redhat.gdb-prs
     redhat.libc-alpha redhat.libc-hacker redhat.bug-glibc
     redhat.glibc-cvs redhat.glibc-linux redhat.bug-gnats
     redhat.gnats-devel redhat.gnats-announce redhat.gnats-cvs
     redhat.gsl-discuss redhat.gsl-announce redhat.gsl-cvs redhat.guile
     redhat.guile-emacs redhat.guile-prs redhat.guile-gtk
     redhat.bug-guile redhat.guile-cvs redhat.guile-emacs-cvs
     redhat.insight redhat.insight-announce redhat.insight-prs
     redhat.installshell redhat.inti redhat.kawa redhat.libffi-discuss
     redhat.libffi-announce redhat.libstdc++ redhat.libstdc++-cvs
     redhat.libstdc++-prs redhat.mauve-discuss redhat.mauve-announce
     redhat.newlib redhat.pthreads-win32 redhat.rhdb
     redhat.rhdb-announce redhat.rhug-rhats redhat.rpm2html-cvs
     redhat.rpm2html-prs redhat.rpm2html redhat.sid redhat.sid-announce
     redhat.sid-cvs redhat.sourcenav redhat.sourcenav-announce
     redhat.sourcenav-prs redhat.win32-x11 redhat.xconq7
     redhat.xconq-announce redhat.xconq-cvs

MacOSX JP Mailing List (http://www.tech-arts.co.jp/macosx/)
     macosx-jp.macosx-jp macosx-jp.macosx-dev-jp macosx-jp.macosx-ws-jp
     macosx-jp.webobjects-jp

SourceForge JP (http://sourceforge.jp)
     All archives served by SourceForge JP are supported by `shimbun'
     library.  Add a group name of your favorite archive to the variable
     `shimbun-sourceforge-jp-mailing-lists', and you can browse it.

Elips Mailing List (http://heimat.jp/~nakaji/elips/)
     elips.elips

Squeak-ja Mailing List (http://lists.squeakfoundation.org/pipermail/squeak-ja/)
     squeak-ja.main

Smalltalkers' Salon Mailing List (http://www.sra.co.jp/smalltalk/SML/archives/)
     sml.main

Squeak-dev Mailing List (http://lists.squeakfoundation.org/pipermail/squeak-dev/)
     squeak-dev.main

Plucker Mailing List (http://www.mail-archive.com/plucker-*@rubberchicken.org/maillist.html)
     plucker.announce plucker.list plucker.dev

pilot-link Mailing List (http://www.pilot-link.org/pipermail/)
     pilot-link.announce pilot-link.devel pilot-link.general
     pilot-link.unix-ng

Coldsync Mailing List (http://www.thedotin.net/maillists/coldsync-hackers/maillist.html)
     coldsync.main

J-Pilot Mailing List (http://www.jpilot.org/pipermail/jpilot/)
     jpilot.main

pilot-mailsync Mailing List (http://lists.gnu-designs.com/pipermail/pilot-mailsync/)
     pilot-mailsync.main

Mozilla Users Mailing List in Japan (http://www.mozilla.gr.jp/ml/logs/moz-users/)
     mozilla-jp.users

tDiary Developers Mailing List in Japan (http://www.tdiary.org/)
     tdiary-ml.devel tdiary-ml.theme

   Please note that userid and passowrd are required for
`mozilla-jp.users' so you have to write;

     machine www.mozilla.gr.jp
     path /ml/logs/moz-users/
     login mozilla
     passwd mozilla

in `~/.w3m/passwd' and remove group and others access permissions from
the file.

Sport Sites Supported by Shimbun
--------------------------------

These are sport sites supported by `shimbun' library.

makanai (http://www.makanai.com/)
     makanai.f1news

F1 FAN (http://www.ksky.ne.jp/~tahara/f1/)
     f1fan.news

TOCHUU F1 EXPRESS (http://f1express.cnc.ne.jp/)
     f1express.F1 f1express.Pari-Dakar f1express.CART
     f1express.All-Japan f1express.WRC f1express.bike
     f1express.Tuka-CLUB f1express.etc f1express.F-Nippon
     f1express.JGTC f1express.LeMans24 f1express.Indi500
     f1express.F3-Japan f1express.Super-Taikyu f1express.AJRC
     f1express.F-Toyota f1express.F-Dream f1express.etc-4-Japan
     f1express.F3-France f1express.F3-England f1express.F3-Germany
     f1express.LeMans-USA f1express.IRL f1express.FSC
     f1express.Int-F3000 f1express.etc-4-int f1express.WGP
     f1express.WSB f1express.R2-1 f1express.Suzuka8 f1express.Motegi7
     f1express.AJ-Motocross f1express.AJ-Trial
     f1express.World-Motocross f1express.WCT f1express.etc-2
     f1express.Inter-GP-Cafe f1express.Takagi f1express.NASCAR
     f1express.Kato f1express.Endo f1express.Sato f1express.Imamiya
     f1express.Toyota-news f1express.F1-release f1express.info

   TOCHUU F1 EXPRESS requires Mule-UCS
(ftp://ftp.m17n.org/pub/mule/Mule-UCS/).  When Mule-UCS is installed
for Emacs-21.2, it is necessary to apply the patch
(http://tsukuba.m17n.org/mule-archive/2002-3/msg00000.html) before
installation.

Misc Sites Supported by Shimbun
-------------------------------

These are misc sites supported by `shimbun' library.  WEB BBS and
serial publications are included.

Yutopia BBS (http://www61.tcup.com/6116/yutopia.html)
     tcup.yutopia

Meadow BBS (http://www66.tcup.com/6629/yutopia.html)
     tcup.meadow

SKK BBS (http://www67.tcup.com/6718/yutopia.html)
     tcup.skk

     Add appropriate configurations to the variable
     `shimbun-tcup-group-alist', you can browse other bulletin board
     systems that are provided at `http://www.tcup.com/'.

VineLinux Errata (http://www.vinelinux.org)
     vinelinux.errata.2x.i386 vinelinux.errata.2x.ppc
     vinelinux.errata.2x.sparc vinelinux.errata.2x.alpha
     vinelinux.errata.1x

2ch
     This is an example to browse Meadow BBS and emacs-w3m BBS on 2ch.
          (setq shimbun-2ch-group-alist
                '(("Meadow" .
                   "http://pc.2ch.net/test/read.cgi/software/1005469775")
                  ("emacs-w3m" .
                   "http://pc.2ch.net/test/read.cgi/unix/1013710106")))

HNS
     This is an example to use `sb-hns'.
          (setq shimbun-hns-group-alist
                '(("arisawa"                           ;; Group Name
                   "http://www.nijino.com/ari/diary/"  ;; URL
                   "ari@mbf.sphere.ne.jp")             ;; E-Mail Address
                  ("miyoshi"
                   "http://www.be.wakwak.com/cgi-bin/sbox/~miyoshi/hns/"
                   "miyoshi@meadowy.org")))

tDiary
     This is an example to use `sb-tdiary'.
          (setq shimbun-tdiary-group-alist
                '(("henahena"                          ;; Group Name
                   "http://www.fan.gr.jp/~ring/d/")    ;; URL
                  ("yoichi"
                   "http://yoichi.geiin.org/d/")))

chalow
     This is an example to use `sb-chalow'.
          (setq shimbun-chalow-group-alist
                '(("yto"                               ;; Group Name
                   "http://nais.to/~yto/clog/"         ;; URL
                   "yto@nais.to")                      ;; E-mail Address
                  ))

Koizumu Cabinet Mail Magazine (http://www.kantei.go.jp/jp/)
     kantei.m-magazine

Patent Office in Japan (http://www.jpo.go.jp/)
     jpo.news jpo.revision jpo.lawguide jpo.details

IBM developerWorks (http://www-6.ibm.com/jp/developerworks/) (in Japanese)
     ibm-dev.java ibm-dev.linux ibm-dev.opensource ibm-dev.webservices
     ibm-dev.xml

Muchy's Palmware Review! (http://muchy.com/)
     muchy.review

palmoslove (http://palmoslove.com/)
     palmoslove.webnews palmoslove.pdanews palmoslove.sitenews

Pocketgames (http://www.pocketgames.jp/)
     pocketgames.news

Wincefan (http://www.wince.ne.jp/)
     wincefan.news

PalmFan (http://www.palmfan.com/)
     palmfan.news palmfan.palmwarefan

Report of Electrical Stores Street (http://homepage1.nifty.com/akiba/plat.html) (in Japanese)
     dennou.report

PCWEB COLUMN Square (http://pcweb.mycom.co.jp/column/)
     pcweb-column.gyokai pcweb-column.benri pcweb-column.hitech
     pcweb-column.business pcweb-column.winxp pcweb-column.bytes
     pcweb-column.newyork pcweb-column.asia pcweb-column.akiba
     pcweb-column.rikei pcweb-column.osx pcweb-column.game
     pcweb-column.smart98 pcweb-column.win2k pcweb-column.msdos
     pcweb-column.muteki pcweb-column.mobile pcweb-column.win98
     pcweb-column.ayashii pcweb-column.melon pcweb-column.linux
     pcweb-column.scrap pcweb-column.siterev pcweb-column.anime
     pcweb-column.soho pcweb-column.trouble pcweb-column.renai
     pcweb-column.dream pcweb-column.tworld pcweb-column.camera
     pcweb-column.denshi pcweb-column.tsushin pcweb-column.shitumon
     pcweb-column.nandemo pcweb-column.hourou pcweb-column.oshigoto
     pcweb-column.tech pcweb-column.speed

Notes Exhibition (http://tsuruo.dominohosting.biz/members/tsuruo/)
     lotusex.news lotusex.library lotusex.operation lotusex.primer
     lotusex.tips lotusex.practical lotusex.qanda lotusex.lounge
     lotusex.bbs

How to make a new shimbun module
================================

`Shimbun' is a library set of emacs-w3m that enables you to read
certain web contents using Gnus, Wanderlust, or Mew as if they were
email messages.  Here we will explain how to make a new `shimbun'
module.

Overview
--------

When you make a new `shimbun' module `foobar' for reading contents of
`http://www.foobar.net', what you have to do first is to put the
following S expressions in the first part of the `sb-foobar.el' file:

     (require 'shimbun)
     (luna-define-class shimbun-foobar (shimbun) ())

We will explain what they are below, so you can understand they are just
incantations now.  You have to use the same suffix `foobar' in the file
name (`sb-foobar.el') and the class name (`shimbun-foobar') as the
second argument for the `luna-define-class' macro.

   Major jobs of the `shimbun-foobar' module can be classified broadly
into the following four categories (note that you may rephrase "folder"
with "group" if you are a Gnus user):

  1. Getting a page source from `http://www.foobar.net' in order to
     gather articles' subjects etc. when a MUA opens the `foobar'
     folder.

  2. Gathering subjects and other necessary informations from the page
     source in order to make headlines of articles and returning them
     as the structured list called `headers'.

  3. Getting a page source for an article from the web site, for
     example, `http://www.foobar.net/053003.html', when MUA requires to
     display an article in the `foobar' folder, and

  4. Removing cruft, e.g. advertisements, from the page source and
     formatting a raw article.

`shimbun-headers' of `shimbun.el' does the first job,
`shimbun-get-headers' does the second, `shimbun-article' does the third
and `shimbun-make-contents' does the last.

   The `shimbun-headers' method does the first job, the
`shimbun-get-headers' method does the second, the `shimbun-article'
method does the third and the `shimbun-make-contents' method does the
last thing.  The default methods for those categories are defined in
the `shimbun.el' module.

   Open the `shimbun.el' file.  You may see unfamiliar definitions like
`luna-define-generic' or `luna-define-method' there.  Hm, they look
like `defun', don't you?  You may also see there's just a doc-string in
the former definition and the same symbol is declared again in the
later form.  And further, there are some symbols only declared by the
`luna-define-generic' form, not by the `luna-define-method' form.  What
on earth are we seeing?  Isn't the program not written in the
Emacs-Lisp language?

   The truth is that the `shimbun' modules use the `luna.el' module
provided by FLIM which enables you to write object oriented programs in
the Emacs-Lisp language.

   There are method programs defined rigidly for the specific purposes
in the `shimbun.el' module.  The `shimbun-headers' method gets a page
source from a certain URL, the `shimbun-get-headers' method gathers
subjects and other informations, etc... (see above).  They do routine
works, so they cannot take proper method to meet various web contents
in the world.  Eh?  Oh, you shouldn't believe in a heresy!

   The `shimbun.el' module only provides the default method functions.
Remember the `defadvice' feature.  There are three ways to modify the
behavior of a function: `:before', `:around' and `:after'.  Similarly,
each default `shimbun' method function can be modified for a certain
purpose (note that the `:around' method-qualifier can be omitted).  And
it should be written specially that the modification will be effective
only when the specified `shimbun' module is selected.

   Now as you may have understood that the `luna-define-generic' form
provides only a husk in a sense, the `luna-define-method' form defines
an actual function which can be different for each `shimbun' module,
and the `luna-define-class' form declares the `shimbun' class in the
first part of the `sb-foobar.el' module.

Getting web page and header information
---------------------------------------

Let's identify a target web page URL to gather subjects and other
informations first.  If a web site uses a frame, a target is only one
of the web pages.  Second, lets create a body of the
`shimbun-index-url' method function using the `luna-define-method' form
in your `sb-foobar.el' file.  And make the user customizable variable
`shimbun-foobar-groups', which we will explain later(1).

     (defvar shimbun-foobar-url "http://www.foobar.net")

     (luna-define-method shimbun-index-url ((shimbun shimbun-foobar))
       shimbun-foobar-url)

     (defvar shimbun-foobar-groups '("news"))

   After you create a body of the `shimbun-index-url' method, the
`shimbun-headers' method can get a web page source since the
`shimbun.el' module already has the default `shimbun-headers' method.
After the `shimbun-headers' method gets a web page source, it calls the
`shimbun-get-headers' method to gather headers information.  As the
`shimbun.el' module does not have the `shimbun-get-headers' method, you
have to create it in your `sb-foobar.el' file.

   Now look carefully in the page source and create the
`shimbun-get-headers' method in your `sb-foobar.el' file.

   Create a regular expression that can gather headers information.
Minimally necessary information are subject, date, author, URL and
`message-id' of an article.  They are used in MUA as Subject, Date,
From, Xref and Message-ID.

   If you want to make an article from a line in a web page source,
like:

     <a href="053003.html">some talks on May 30(posted by Mikio &lt;foo@bar.net&gt;)</a>

use the following regexp:

     "<a href=\"\\(\\([0-9][0-9][0-9][0-9]\\)\\.html\\)\">\\([^<(]+\\)(posted by \\([^<]+\\))<\/a>"

You can get a value for Xref by `(match-string 1)'.  You can get a
value for Date by modifying a value of `(match-string 2)'.  Subject by
`(match-string 3)' and From from `(match-string 4)'.  You can modify
them further for showing additional information in MUA.  See the
`sb-muchy.el' file which makes its original subject form from a web
page source.

   If URL of an article is a relative path like above, use
`w3m-expand-url' to expand it before putting information to header.  If
each article doesn't have a each unique URLs (i.e. URL of headers and
URL of articles are just same), you have to ask Emacs to remember body
of an article when gathering headers information, For more detail see
the files `sb-palmfan.el', `sb-dennou.el' and `sb-tcup.el'.

   Sometimes you cannot identify Date information when gathering headers
information only from a web page source.  If so, leave it, just set a
null string, `""' to its value.  If you can identify Date only when you
see contents of an article, you can set it at that time by using
`shimbun-make-contents' method.  And you may use a fixed From for a web
site (e.x. "webmaster@foobar.net").

   Be careful when you build a message-id.  Make sure it has uniqueness
otherwise you may not be able to read some articles in the
`shimbun'(2).  Assure uniqueness by building message-id using date
information, a domain of the page and/or a part of URL of the page.
And use `@' but `:' as a part of message-id in order to display inline
images.  See RFC2387 and RFC822 for more detail.

   Put these information to header using function `shimbun-make-header'
of the `shimbun.el' module.

   A bare bone of `shimbun-get-headers' in your `sb-foobar.el' file is
as follows:

     (luna-define-method shimbun-get-headers ((shimbun shimbun-foobar)
                                              &optional range)
       (let ((regexp "....")
             subject from date id url headers)
         ...
         (catch 'stop
           (while (re-search-forward regexp nil t nil)
             ...
             (when (shimbun-search-id shimbun id)
               (throw 'stop nil))
             (push (shimbun-make-header
                    0 (shimbun-mime-encode-string subject)
                    (shimbun-mime-encode-string from)
                   date id "" 0 0 url)
                   headers)))
         headers))

Note that you can access `shimbun-foobar' instance via temporary
variable `shimbun' in the method.

   Now we will explain a user variable `shimbun-foobar-groups'.

   Assume that you have two groups of articles in
`http://www.foobar.net' and there are two different web pages for such
groups in where `shimbun' module gathers header information.  For
examples, there are what's new information of the web site in
`http://www.foobar.net/whatsnew/index.hmtl', and there are archive
lists of email messages posted to ML in
`http://www.foobar.net/ml/index.html'.  In such case you may want to
access the group by `shimbun' folders `foobar.whatsnew' and
`foobar.ml'.  If so, put the following S expressions to the
`sb-foobar.el' file.

     (defvar shimbun-foobar-url "http://www.foobar.net")

     (defvar shimbun-foobar-group-path-alist
       '(("whatsnew" . "/whatsnew/index.html")
         ("ml" . "/ml/index.html")))

     (defvar shimbun-foobar-groups
       (mapcar 'car shimbun-foobar-group-path-alist))

     (luna-define-method shimbun-index-url ((shimbun shimbun-foobar))
       (concat shimbun-foobar-url
               (cdr (assoc (shimbun-current-group-internal shimbun)
                           shimbun-foobar-groups))))

You can get the current group by using
`shimbun-current-group-internal'.  You can use it in
`shimbun-get-headers' method (or others) in order to change its
behavior in accordance with the current group.

   Each `shimbun' module needs at least one group.  There is not a
special rule for naming a group, but if you don't find out a good name,
use `news' or `main'.

   ---------- Footnotes ----------

   (1) At least one group is necessary for each `shimbun' module even
if you don't want it.

   (2) And more, you may not be able to read actual email messages from
someone when message-ids conflict!

Displaying an article
---------------------

`shimbun-article' method defined in the `shimbun.el' module gets URL
from Xref information of header, get a web page source from the URL,
and call `shimbun-make-contents' in working buffer of the source.
Major job of `shimbun-make-contents' is to process such HTML.  Imagine
that a working buffer has a web page source of an article.
`shimbun-make-contents' defined in the `shimbun.el' module insert (i)
header information to top of the buffer, (ii) `<html>', `<body>' and
etc. right after the information, and (iii) `</body>' and `</html>' to
end of the buffer.  MUA displays an article as a HTML mail.

   If you don't want to process an article, you don't have to define
`shimbun-make-contents' in the `sb-foobar.el' module.

   If you want to remove some part of a web page source of an article at
its top and its end, set regexp to `shimbun-foobar-content-start' that
matches content start and `shimbun-foobar-content-end' that matches
content end.

     (defvar shimbun-foobar-content-start "^<body>$")
     (defvar shimbun-foobar-content-end "^<\/body>$")

`shimbun-make-contents' defined in the `shimbun.el' module will remove
HTML source from `point-min' to `shimbun-foobar-content-start' and from
`shimbun-foobar-content-end' to `point-max' using the regexps.  Note
that it will not remove any HTML source when either of the regexp
searches fails.

   If you want to remove unnecessary parts (e.x. advertisements)
diligently by some regexps, define `shimbun-make-contents' in your new
`sb-foobar.el' file with `luna-define-method' specifying
method-qualifier `:before' and clean up an article before
`shimbun-make-contents' of the `shimbun.el' module is called(1).  Don't
forget to use `save-excursion' in `shimbun-make-contents' with
`:before' to save point so that a parent method can work properly.

     (luna-define-method shimbun-make-contents :before ((shimbun shimbun-foobar)
                                                        header)
       (save-excursion
         ;; cleaning up
         (while (re-search-forward "..." nil t nil)
           (delete-region (match-beginning 0) (match-end 0)))
         ...
         ))

For more details see `shimbun-make-contents' in the `sb-ibm-dev.el'
file.

   I said in the subsection of Getting web page and header information
that if each article doesn't have a each unique URLs you
have to ask Emacs to remember body of an article when gathering headers
information,  In such case you don't have to get a web page from URL of
Xref in `shimbun-article' method.  Just get texts from Emacs memories
and put them with pretty printing.  For more detail see definitions of
`shimbun-article' method of `sb-palmfan.el', `sb-dennou.el' or
`sb-tcup.el'.

   ---------- Footnotes ----------

   (1) As you may know, a method that is declared with `:before' is
called first and succeedingly a method of the same name that is
declared without `:before' is called.  If you declare a method without
any method-qualifier, it will overwrite a method of the same name in
parent class.

Inheriting shimbun module
-------------------------

There are some famous mailing list manager (or archiver).

   * Mailman

     The GNU Mailing List Manager, formerly called as `pipermail'.  See
     `http://www.gnu.org/software/mailman/index.html' for detail.

   * MHonArc

     See `http://www.oac.uci.edu/indiv/ehood/mhonarc.html' for detail.

   * fml

     fml mailing list server/manager.  See
     `http://www.fml.org/software/fml/' for detail.

   * mailarc

     See `http://cvs.namazu.org/mailarc/' for detail.

   If you find out one of such mailing list managers' names in a web
page source when you analyze it in the step of Getting web page and header information,
you are very lucky(1).  The modules
`sb-mailman.el', `sb-mhonarc.el', `sb-fml.el' and `sb-mailarc.el' have
the `shimbun-get-headers' method, etc, already, when you write small
code that is not defined in such `shimbun' modules, your new
`sb-foobar.el' module works!

   If you use the `sb-mailman.el' module, write the following S
expressions to the top of the `sb-foobar.el' file:

     (require 'shimbun)
     (require 'sb-mailman)
     (luna-define-class shimbun-foobar (shimbun-mailman) ())

Those above mean that `shimbun' module `shimbun-foobar' inherits
shimbun-mailman class(2) and methods defined in the `sb-mailman.el'
module will be used in `shimbun-foobar' by default.  You can overwrite
some of parent methods, if necessary.

   See the `sb-pilot-mailsync.el' file as a sample that uses the
`sb-mailman.el' module.  You can feel how easy to create a new
`shimbun' module by using such parent modules.

   Note that there are some localized version of such mailing list
manager, for examples, some of them show Date information in Japanese.
The modules `sb-mailman.el', `sb-mhonarc.el', `sb-fml.el' and
`sb-mailarc.el' assumes that mailing list managers are not localized.

   If you want to read via `shimbun' a web site that uses localized
mailing list manager, you may have to overwrite some methods in the
parent module.

   ---------- Footnotes ----------

   (1) Such mailing list managers often show their own name in an
archive list page

   (2) i.e. shimbun-mailman class is a parent class.

Some knick-knacks using emacs-w3m
*********************************

Here are some handy tips to use emacs-w3m with other Emacs facilities.

   * browse-url

     You can use emacs-w3m with the `browse-url' feature.  For instance,
     put the following lines in your `~/.emacs' file:

          (setq browse-url-browser-function 'w3m-browse-url)
          (autoload 'w3m-browse-url "w3m" "Ask emacs-w3m to show a URL." t)
          (global-set-key "\C-xm" 'browse-url-at-point)

     Emacs-w3m will now be invoked when you type the `C-x m' key on a
     string which looks like a URL in any Emacs buffer.  In addition,
     you can use emacs-w3m to preview an HTML file that you are just
     editing by typing the `C-c C-v' key (note that you need to use
     Emacs and the `html-mode' major mode to edit the HTML file).

     If you'd like to use another web browser than emacs-w3m when using
     the `C-x m' key when you are in an emacs-w3m buffer (who wants to
     do so?), add the following advice to `~/.emacs' file:

          (defadvice browse-url-at-point
            (around change-browse-url-browser-function activate)
            "Use Netscape only when it is invoked in an emacs-w3m buffer."
            (let ((browse-url-browser-function
                   (if (eq major-mode 'w3m-mode)
                       'browse-url-netscape
                     'w3m-browse-url)))
              ad-do-it))

   * dired

     You can use emacs-w3m to browse an HTML file in a `dired' buffer by
     typing the `C-x m' key.  Use the following settings in your
     `~/.emacs' file:

          (eval-after-load "dired"
            '(define-key dired-mode-map "\C-xm" 'dired-w3m-find-file))

          (defun dired-w3m-find-file ()
            (interactive)
            (require 'w3m)
            (let ((file (dired-get-filename)))
              (if (y-or-n-p (format "Use emacs-w3m to browse %s? "
                                    (file-name-nondirectory file)))
                  (w3m-find-file file))))

   * hnf-mode

     You can see the newest diary using emacs-w3m and the hyper nikki
     system.  Put the following lines in your `~/.emacs' file and type
     the `C-c C-b' key in an `hnf-mode' buffer:

          (autoload 'w3m-browse-url "w3m" nil t)
          (defun w3m-hnf-browse-url-w3m (url &optional new-window)
            (interactive (browse-url-interactive-arg "URL: "))
            (save-selected-window
              (pop-to-buffer (get-buffer-create "*w3m*"))
              (w3m-browse-url url new-window)))
          (setq hnf-browse-url-browser-function #'w3m-hnf-browse-url-w3m)

   * Gnus

     You've mistaken the entrance if you are a Gnus user and this
     section is the first page you read in this Info.  See
     Hooking into MUAs first.

     By default, Gnus will not apply the treatment variables, for
     instance `gnus-treat-strip-banner', to `text/html' parts.  To have
     them applied to `text/html' parts automatically, there are two
     ways to do that:

          ;; Apply all the treatments to text/html parts.
          (eval-after-load "gnus-art"
            '(add-to-list 'gnus-article-treat-types "text/html"))

          ;; Apply a certain treatment to text/html parts.
          (setq gnus-treat-strip-banner '(or t (typep "text/html")))

     Also Customizing Articles (gnus), for
     details.

     In addition, the experimental code below is used to display
     `multipart/related' pictures.  The place might be something wrong.

          (eval-after-load "gnus-art"
            '(or (assoc "multipart/related" gnus-mime-multipart-functions)
                 (setq gnus-mime-multipart-functions
                       (cons
                        (cons
                         "multipart/related"
                         (byte-compile
                          (lambda (handle)
                            (gnus-mime-display-mixed (cdr handle)))))
                        gnus-mime-multipart-functions))))

   * yahtml-mode

     You can use emacs-w3m to preview an HTML file that just you are
     editing with the `yahtml-mode'.  Here is an example:

          (autoload 'w3m-goto-url "w3m")
          (defadvice yahtml-browse-html
            (around w3m-yahtml-browse-html activate compile)
            (w3m-goto-url (ad-get-arg 0) t))

Mailing list and submitting bug reports
***************************************

We have set up a mailing list to discuss all things emacs-w3m.  You can
post without subscribing.  If you find a bug, have a feature request, or
have written some code, don't hesitate to post to the list.  And if
you're just a user and like the program, please tell us too!

   The address is:

     Emacs-w3m Mailing List <emacs-w3m@namazu.org>

   You can also send a bug report using the `report-emacs-w3m-bug'
command (or the `C-c C-b' key) if you have set the `mail-user-agent'
variable that will work properly.

   English and Japanese can be used when posting to this list, since
many of its members are Japanese.  Articles posted to the list are
opened to the public and you can read them on the web (at
`http://emacs-w3m.namazu.org/ml/'), or in NetNews (group
`gmane.emacs.w3m' on the server `news.gmane.org').

   If you want to receive articles by mail, send a mail containing

     subscribe Your Name

   (please write your name, not your email address) in its body to
`emacs-w3m-ctl@namazu.org', then you can subscribe to the list.  To
unsubscribe from it, send a mail containing just

     # bye

   in its body to `emacs-w3m-ctl@namazu.org'.

Details of some emacs-w3m functions
***********************************

Persons who wrote this manual
*****************************

   * Romain FRANCOISE

   * NAKAJIMA Mikio

   * Yoichi NAKAYAMA

   * Hideyuki SHIRAI

   * TSUCHIYA Masatoshi

   * Katsumi Yamaoka

   * Masatake YAMATO

Index
*****